Unit ClassExports;

Interface

Uses Sorting, JclPEImage, ComCtrls;

Const
      EXPORTY_SLOUPEC_FNNAME  = 0;
      EXPORTY_SLOUPEC_ORDINAL = 1;
      EXPORTY_SLOUPEC_BASE    = 2;
      EXPORTY_MAX_SLOUPCU     = 3;

Type
    TExportySortStyle = (essFnName, essOrdinal,
                         essBase);
    TExportRecord = Record
                    FnName  : String;
                    Base    : Cardinal;
                    Ordinal : Integer;
                    end;
    PExportRecord = ^TExportRecord;
    TExporty = Class (TSortList)
               Private
                FBase : Cardinal;
                FSortStyle : TExportySortStyle;
                FPID : Cardinal;
                FModuleName : String;
               Protected
                Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Override;
                Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Override;
                Procedure SetSortStyle(H:TExportySortStyle);
                Procedure Enumerate; Override;
               Public
                Constructor Create(AListView:TListView; APID,ABase:Cardinal); Reintroduce; Virtual;
                Procedure   ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Override;
                Procedure   ListViewColumnClick(Sender: TObject; Column: TListColumn); Override;

                Function GetExport(Index:Integer):PExportRecord;
                Property SortStyle : TExportySortStyle Read FSortStyle Write SetSortStyle;
                Property PID : Cardinal Read FPID;
                Property ModuleName : String Read FModuleName Write FModuleName;
               end;

Implementation

Uses SysUtils, Classes, ModuleOperationImport;

Const
    KRITERIUM_FNNAME   = 0;
    KRITERIUM_ORDINAL  = 1;
    KRITERIUM_BASE     = 2;


Constructor TExporty.Create(AListView:TListView; APID,ABase:Cardinal);
begin
Inherited Create(AListView);
FPID:=APID;
FModuleName:='';
FSortStyle:=essFnName;
Opacne:=False;
Kriteria.Clear;
Kriteria.Add(Pointer(KRITERIUM_FNNAME));
PocetSloupcu:=EXPORTY_MAX_SLOUPCU;
FJmena.LoadFromFile('Data\export.col');
FBase:=ABase;
end;

Function TExporty.GetExport(Index:Integer):PExportRecord;
begin
Result:= Items[Index];
end;

Function  TExporty.JeVetsi(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PExportRecord;
begin
Result:=False;
X:=A;
Y:=B;
Case K OF
     KRITERIUM_FNNAME  : Result:= AnsiStrComp(PAnsiChar(X.FnName),PAnsiChar(Y.FnName)) > 0;
     KRITERIUM_ORDINAL : Result:= X.Ordinal > Y.Ordinal;
     KRITERIUM_BASE    : Result:= X.Base > Y.Base;
     end;
end;

Function  TExporty.JeRovno(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PExportRecord;
begin
Result:=False;
X:=A;
Y:=B;
Case K OF
     KRITERIUM_FNNAME  : Result:= AnsiStrComp(PAnsiChar(X.FnName),PAnsiChar(Y.FnName)) = 0;
     KRITERIUM_ORDINAL : Result:= X.Ordinal = Y.Ordinal;
     KRITERIUM_BASE    : Result:= X.Base = Y.Base;
     end;
end;

Procedure TExporty.SetSortStyle(H:TExportySortStyle);
begin
If H = FSortStyle Then
   begin
   Opacne:=Not Opacne;
   Serad;
   Exit;
   end;
Opacne:=False;
FSortStyle:=H;
Kriteria.Clear;
Kriteria.Add(Pointer(KRITERIUM_FNNAME));
Case H Of
     essFnName  : Kriteria.Insert(0,Pointer(KRITERIUM_FNNAME));
     essOrdinal : Kriteria.Insert(0,Pointer(KRITERIUM_ORDINAL));
     essBase    : Kriteria.Insert(0,Pointer(KRITERIUM_BASE));
     end;
Serad;
end;

Procedure TExporty.Enumerate;
Var A : TStringList;
    X : PExportRecord;
    I : Integer;
    S : String;
begin
If Assigned(ListView) Then
   ListView.Items.Count:=0;
Clear;
A:=GetExportListByModuleBaseAddr(FBase,FPID);
For I:=0 To A.Count-1 Do
    begin
    New(X);
    S:=A[I];
    X.FnName:=Copy(S,1,Pos('**',s)-1);
    System.Delete(S,1,Pos('**',S)+1);
    X.Base:=StrToInt64(Copy(S,1,Pos('**',s)-1))+FBase;
    System.Delete(S,1,Pos('**',S)+1);
    X.Ordinal:=StrToInt64(S);
    Add(X);
    end;
Serad;
If Assigned(FListView) Then
   begin
   FListView.Invalidate;
   FListView.Items.Count:=Count;
   end;
end;

Procedure TExporty.ListViewVykresliJednoho(Sender:TObject; Item:TListItem);
Var E : PExportRecord;
begin
E:=GetExport(Item.Index);
With Item Do
     begin
     If SloupecDejStav(EXPORTY_SLOUPEC_FNNAME) Then
        Caption:=E.FnName;
     If SloupecDejStav(EXPORTY_SLOUPEC_BASE) Then
        SubItems.Add(IntToStr(Int64(E.Ordinal)));
     If SloupecDejStav(EXPORTY_SLOUPEC_ORDINAL) Then
        SubItems.Add('$'+IntToHex(Int64(E.Base),8));
     end;
end;

Procedure TExporty.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
SortStyle:=TExportySortStyle(Column.Tag);
Enumerate;
end;

End.
