Unit ClassImports;

Interface

Uses ModuleOperationImport, Sorting,
     Windows, ComCtrls,
     SysUtils, Classes;


Const IMPORT_STATUS_OK          = 0;
      IMPORT_STATUS_APIHOOK     = 1;
      IMPORT_STATUS_BREAKPOINT  = 2;
      IMPORT_STATUS_IAT_HOOK    = 5;
      IMPORT_STATUS_NOT_DETERMINED = 8;

      IMPORTS_SLOUPEC_IMPORTNAME    = 0;
      IMPORTS_SLOUPEC_IMPORTORDINAL = 1;
      IMPORTS_SLOUPEC_IMPORTADDRESS = 2;
      IMPORTS_SLOUPEC_DLLNAME       = 3;
      IMPORTS_SLOUPEC_STATUS        = 4;
      IMPORTS_MAX_SLOUPCU           = 5;

Type
      TImportsSortStyle = (issImportName, issImportOrdinal, issImportAddress,issDllName, issStatus);
      TImportItem = Record
                    ImportName : String;
                    DLLName    : String;
                    Address    : Cardinal;
                    Ordinal    : Integer;
                    Status     : DWORD;
                    end;
      PImportItem = ^TImportItem;

      TModuleImports = Class (TSortList)
                       Private
                        FPID : Cardinal;
                        FModuleName : String;
                        FBase : Cardinal;
                        FSortStyle : TImportsSortStyle;
                       Protected
                        Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Override;
                        Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Override;
                        Procedure SetSortStyle(H:TImportsSortStyle);
                       Public
                        Constructor Create(AListView:TListView; APID:Cardinal); Reintroduce; Virtual;
                        Procedure   Enumerate;
                        Function    GetImport(Index:Integer):PImportItem;
                        Procedure   ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Override;
                        Procedure   ListViewColumnClick(Sender: TObject; Column: TListColumn); Override;
                        Property    SortStyle : TImportsSortStyle Read FSortStyle Write SetSortStyle;
                        Property    PID : Cardinal Read FPID;
                        Property    ModuleName : String Read FModuleName Write FModuleName;
                        Property    Base : Cardinal Read FBase Write FBase;
                       end;

Implementation

Uses TlHelp32, Forms;

Const KRITERIUM_IMPORTS_IMPORTNAME    = 0;
      KRITERIUM_IMPORTS_IMPORTORDINAL = 1;
      KRITERIUM_IMPORTS_IMPORTADDRESS = 2;
      KRITERIUM_IMPORTS_DLLNAME       = 3;
      KRITERIUM_IMPORTS_STATUS        = 4;

Constructor TModuleImports.Create(AListView:TListView; APID:Cardinal);
begin
Inherited Create(AListView);
Kriteria.Add(Pointer(KRITERIUM_IMPORTS_IMPORTNAME));
FSortStyle:=issImportName;
Opacne:=False;
FJmena.LoadFromFile(ExtractFilePath(Application.ExeName)+'Data\import.col');
PocetSloupcu:=IMPORTS_MAX_SLOUPCU;
FPID:=APID;
ModuleName:='';
Base:=0;
end;

Procedure TModuleImports.SetSortStyle(H:TImportsSortStyle);
begin
If H = FSortStyle Then
   Opacne:= Not Opacne
Else begin
     Opacne:=False;
     FSortStyle:=H;
     If Kriteria.Count > 1 Then
        Kriteria.Delete(0);
     Case FSortStyle Of
          issImportAddress : Kriteria.Insert(0,Pointer(KRITERIUM_IMPORTS_IMPORTADDRESS));
          issImportOrdinal : Kriteria.Insert(0,Pointer(KRITERIUM_IMPORTS_IMPORTORDINAL));
          issDLLName       : Kriteria.Insert(0,Pointer(KRITERIUM_IMPORTS_DLLNAME));
          IssStatus        : Kriteria.Insert(0,Pointer(KRITERIUM_IMPORTS_STATUS));
          end;
     end;
Serad;
end;

Function  TModuleImports.JeVetsi(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PImportItem;
begin
Result:=False;
X:=A;
Y:=B;
Case K OF
     KRITERIUM_IMPORTS_IMPORTNAME    : Result:= AnsiStrComp(PAnsiChar(X.ImportName),PAnsiChar(Y.ImportName)) > 0;
     KRITERIUM_IMPORTS_IMPORTADDRESS : Result:= DWORD(X.Address) > DWORD(Y.Address);
     KRITERIUM_IMPORTS_IMPORTORDINAL : Result:= X.Ordinal > Y.Ordinal;
     KRITERIUM_IMPORTS_DLLNAME       : Result:= AnsiStrComp(PAnsiChar(X.DLLName),PAnsiChar(Y.DLLName)) > 0;
     KRITERIUM_IMPORTS_STATUS        : Result:= X.Status > Y.Status;
     end;
end;

Function  TModuleImports.JeRovno(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PImportItem;
begin
Result:=False;
X:=A;
Y:=B;
Case K OF
     KRITERIUM_IMPORTS_IMPORTNAME    : Result:= AnsiStrComp(PAnsiChar(X.ImportName),PAnsiChar(Y.ImportName)) = 0;
     KRITERIUM_IMPORTS_IMPORTADDRESS : Result:= DWORD(X.Address) = DWORD(Y.Address);
     KRITERIUM_IMPORTS_IMPORTORDINAL : Result:= X.Ordinal = Y.Ordinal;
     KRITERIUM_IMPORTS_DLLNAME       : Result:= AnsiStrComp(PAnsiChar(X.DLLName),PAnsiChar(Y.DLLName)) = 0;
     KRITERIUM_IMPORTS_STATUS        : Result:= X.Status = Y.Status;
     end;
end;

Function TModuleImports.GetImport(Index:Integer):PImportItem;
begin
Result:=Items[Index];
end;

Procedure TModuleImports.Enumerate;
Var A      : TStringList;
    Import : PImportItem;
    I      : Integer;
    S      : String;
    Buffer   : Byte;
    ME       : ModuleEntry32;
    hSnap    : THandle;
    Read     : Cardinal;
begin
If Assigned(ListView) Then
   ListView.Items.Count:=0;
Clear;
If (Base = 0) Or (Base > $80000000) Or (FPID = 0) Then
   A:=GetImportListByModuleName(ModuleName)
Else A:=GetImportListByModuleBaseAddr(Base,PID);
For I:=0 To A.Count-1 Do
    begin
    S:=A[I];
    New(Import);
    Import.ImportName:=Copy(S,1,Pos(';;',S)-1);
    System.Delete(S,1,Pos(';;',S)+1);
    Import.Ordinal:=StrToInt64(Copy(S,1,Pos(';;',S)-1));
    System.Delete(S,1,Pos(';;',S)+1);
    Import.DLLName:=Copy(S,1,Pos(';;',S)-1);
    System.Delete(S,1,Pos(';;',S)+1);
    Import.Address:=StrToInt64(S);
    Import.Status:=IMPORT_STATUS_OK;
    Import.Status:=IMPORT_STATUS_NOT_DETERMINED;
    Add(Import);
    end;
A.Free;
Serad;
If Assigned(FListView) Then
   begin
   FListView.Invalidate;
   FListView.Items.Count:=Count;
   end;
end;

Procedure TModuleImports.ListViewVykresliJednoho(Sender:TObject; Item:TListItem);
Var I : PImportItem;
begin
I:=GetImport(Item.Index);
With Item Do
     begin
     If SloupecDejStav(IMPORTS_SLOUPEC_IMPORTNAME) Then
        Caption:=I.ImportName;
     If SloupecDejStav(IMPORTS_SLOUPEC_IMPORTORDINAL) Then
        SubItems.Add(IntToStr(Int64(I.Ordinal)));
     If SloupecDejStav(IMPORTS_SLOUPEC_IMPORTADDRESS) Then
        SubItems.Add('$'+IntToHex(Int64(I.Address),8));
     If SloupecDejStav(IMPORTS_SLOUPEC_DLLNAME) Then
        SubItems.Add(ExtractFileName(I.DLLName));
     If SloupecDejStav(IMPORTS_SLOUPEC_STATUS) Then
        begin
        Case I.Status Of
             IMPORT_STATUS_OK             : SubItems.Add('Ok');
             IMPORT_STATUS_BREAKPOINT     : SubItems.Add('Breakpoint');
             IMPORT_STATUS_IAT_HOOK       : SubItems.Add('IAT hook');
             IMPORT_STATUS_APIHOOK        : SubItems.Add('API hook');
             IMPORT_STATUS_NOT_DETERMINED : SubItems.Add('Not determined');
             end;
        end;
     end;
end;

Procedure TModuleImports.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
Enumerate;
SortStyle:=TImportsSortStyle(Column.Tag);
end;

End.
