Unit ClassMemPages;

Interface

Uses Sorting, Windows, Forms, ComCtrls;

Const
      MEMPAGES_SLOUPEC_ADDR          = 0;
      MEMPAGES_SLOUPEC_SIZE          = 1;
      MEMPAGES_SLOUPEC_TYPE          = 2;
      MEMPAGES_SLOUPEC_INITIALACCESS = 3;
      MEMPAGES_SLOUPEC_ACCESS        = 4;
      MEMPAGES_SLOUPEC_TYPE2         = 5;
      MEMPAGES_SLOUPEC_NAME          = 6;
      MEMPAGES_MAX_SLOUPCU           = 7;

Type
      TMemPagesSortStyle = (mpsAddr, mpsSize, mpsType, mpsInitialAccess, mpsAccess, mpsType2, mpsName);
      TMemPagesRecord    = Record
                           MemInfo : _MEMORY_BASIC_INFORMATION;
                           Name    : String;
                           end;
      PMemPagesRecord    = ^TMemPagesRecord;

      TMemPages = Class (TSortList)
                  Private
                   FSortStyle : TMemPagesSortStyle;
                   FPID : Cardinal;
                  Protected
                   Procedure SetSortStyle(H:TMemPagesSortStyle);  Reintroduce;
                   Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Override;
                   Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Override;
                  Public
                   Constructor Create(AListView:TListView; APID:Cardinal); Reintroduce;
                   Function GetMemPage(Index:Integer):PMemPagesRecord;
                   Procedure Enumerate; Override;
                   Procedure   ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Override;
                   Procedure   ListViewColumnClick(Sender: TObject; Column: TListColumn); Override;
                   Procedure ShowContent(Index:Integer);
                   Property SortStyle : TMemPagesSortStyle Read FSortStyle Write SetSortStyle;
                  end;

Implementation

Uses PProcImport, SysUtils, PSAPI,
     ModuleOperationImport, TlHelp32,
     HandlesImport, FMImport,
     ObjectContentForm;

Const
      KRITERIUM_BASE          = 0;
      KRITERIUM_SIZE          = 1;
      KRITERIUM_TYPE          = 2;
      KRITERIUM_INITIALACCESS = 3;
      KRITERIUM_ACCESS        = 4;
      KRITERIUM_TYPE2         = 5;
      KRITERIUM_NAME          = 6;

Constructor TMemPages.Create(AListView:TListView; APID:Cardinal);
begin
Inherited Create(AListView);
FPID:=APID;
PocetSloupcu:=MEMPAGES_MAX_SLOUPCU;
FJmena.LoadFromFile(ExtractFilePath(Application.ExeName)+'Data\mempage.col');
Kriteria.Add(Integer(KRITERIUM_BASE));
Opacne:=False;
FSortStyle:=mpsAddr;
end;

Procedure TMemPages.SetSortStyle(H:TMemPagesSortStyle);
begin
If H = FSortStyle Then
   begin
   Opacne:= Not Opacne;
   Serad;
   Exit;
   end;
Opacne:=False;
Kriteria.Clear;
Kriteria.Add(Pointer(KRITERIUM_BASE));
FSortStyle:=H;
Case H Of
     mpsAddr          : Kriteria.Insert(0,Pointer(KRITERIUM_BASE));
     mpsSize          : Kriteria.Insert(0,Pointer(KRITERIUM_SIZE));
     mpsType          : Kriteria.Insert(0,Pointer(KRITERIUM_TYPE));
     mpsInitialAccess : Kriteria.Insert(0,Pointer(KRITERIUM_INITIALACCESS));
     mpsAccess        : Kriteria.Insert(0,Pointer(KRITERIUM_ACCESS));
     mpsType2         : Kriteria.Insert(0,Pointer(KRITERIUM_TYPE2));
     mpsName          : Kriteria.Insert(0,Pointer(KRITERIUM_NAME));
     end;
Serad;
end;

Function TMemPages.JeVetsi(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PMemPagesRecord;
begin
X:=A;
Y:=B;
Case K Of
     KRITERIUM_BASE          : Result:=Cardinal(X.MemInfo.BaseAddress) > Cardinal(Y.MemInfo.BaseAddress);
     KRITERIUM_SIZE          : Result:=X.MemInfo.RegionSize > Y.MemInfo.RegionSize;
     KRITERIUM_TYPE          : Result:=X.MemInfo.State > Y.MemInfo.State;
     KRITERIUM_INITIALACCESS : Result:=X.MemInfo.AllocationProtect > Y.MemInfo.AllocationProtect;
     KRITERIUM_ACCESS        : Result:=X.MemInfo.Protect > Y.MemInfo.Protect;
     KRITERIUM_TYPE2         : Result:=X.MemInfo.Type_9 > Y.MemInfo.Type_9;
     KRITERIUM_NAME          : Result:=AnsiStrComp(PAnsiChar(X.Name),PAnsiChar(Y.Name)) > 0;
     Else                      Result:=False;
     end;
end;

Function TMemPages.JeRovno(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PMemPagesRecord;
begin
X:=A;
Y:=B;
Case K Of
     KRITERIUM_BASE          : Result:=Cardinal(X.MemInfo.BaseAddress) = Cardinal(Y.MemInfo.BaseAddress);
     KRITERIUM_SIZE          : Result:=X.MemInfo.RegionSize = Y.MemInfo.RegionSize;
     KRITERIUM_TYPE          : Result:=X.MemInfo.State = Y.MemInfo.State;
     KRITERIUM_INITIALACCESS : Result:=X.MemInfo.AllocationProtect = Y.MemInfo.AllocationProtect;
     KRITERIUM_ACCESS        : Result:=X.MemInfo.Protect = Y.MemInfo.Protect;
     KRITERIUM_TYPE2         : Result:=X.MemInfo.Type_9 = Y.MemInfo.Type_9;
     KRITERIUM_NAME          : Result:=AnsiStrComp(PAnsiChar(X.Name),PAnsiChar(Y.Name)) = 0;
     Else                      Result:=False;
     end;
end;

Function TMemPages.GetMemPage(Index:Integer):PMemPagesRecord;
begin
Result:= Items[Index];
end;

Var P : TMemPages;

Procedure TMemPages.Enumerate;

 Function MemCallBack(Mem:_MEMORY_BASIC_INFORMATION):Boolean; StdCall;
 Var X : PMemPagesRecord;
     Buffer : PAnsiChar;
     hProcess : THandle;
     hSearch : THandle;
     ME       : ModuleEntry32;
 begin
 Result:=True;
 New(X);
 If (Mem.State = MEM_FREE) Or (Mem.State = MEM_RESERVE) Then
    begin
    Mem.Type_9:=INVALID_HANDLE_VALUE;
    Mem.AllocationProtect:=INVALID_HANDLE_VALUE;
    Mem.Protect:=INVALID_HANDLE_VALUE;
    end;
 X.MemInfo:=Mem;
 X.Name:='';
 Case Mem.Type_9 Of
      MEM_MAPPED : begin
                   hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_OPERATION Or PROCESS_VM_READ,False,P.FPID);
                   If hProcess > 0 Then
                      begin
                      Buffer:=StrAlloc(MAX_PATH+1);
                      If GetMappedFileName(hProcess,Mem.BaseAddress,Buffer,MAX_PATH+1) <> 0 Then
                         begin
                         X.Name:=Buffer;
                         X.Name:=UpravNazev(X.Name);
                         end;
                      CloseHandle(hProcess);
                      end;
                   end;
      MEM_IMAGE   : begin
                    hSearch:=ModuleSearchInit(P.FPID);
                    If hSearch > 0 Then
                       begin
                       ME.dwSize:=SizeOf(ME);
                       If ModuleSearchFirst(hSearch,ME) Then
                          begin
                          Repeat
                          If (Cardinal(Mem.BaseAddress) >= Cardinal(ME.modBaseAddr)) And
                             (cardinal(Mem.BaseAddress) < Cardinal(ME.modBaseAddr)+ME.modBaseSize) Then
                             begin
                             X.Name:=ME.szModule;
                             Break;
                             end;
                          Until Not ModuleSearchNext(hSearch,ME);
                          end;
                       ModuleSearchDestroy(hSearch);
                       end;
                    end;
      end;
 P.Add(X);
 end;

begin
P:=Self;
If Assigned(FListView) Then
   FListView.Items.Count:=0;
Clear;
DejOblastiPametiProcesu(FPID,@MemCallback);
Serad;
If Assigned(FListView) Then
   begin
   FListview.Items.Count:=Count;
   FListView.Invalidate;
   end;
end;

Procedure TMemPages.ListViewVykresliJednoho(Sender:TObject; Item:TListItem);
Var M : PMemPagesRecord;
    Pom : Cardinal;
    S: String;
begin
M:=GetMemPage(Item.Index);
With Item Do
     begin
     Caption:='$'+IntToHex(Int64(M.MemInfo.BaseAddress),8);
     If SloupecDejStav(MEMPAGES_SLOUPEC_SIZE) Then
        SubItems.Add(IntToStr(Int64(M.MemInfo.RegionSize Div 1024))+' KB ' );
     If SloupecDejStav(MEMPAGES_SLOUPEC_TYPE) Then
        begin
        Case M.MemInfo.State Of
             MEM_COMMIT  : SubItems.Add('Alokovno');
             MEM_RESERVE : SubItems.Add('Reservovno');
             MEM_FREE    : SubItems.Add('Voln');
             Else          SubItems.Add('');
             end;
        end;
     If SloupecDejStav(MEMPAGES_SLOUPEC_INITIALACCESS) Then
        begin
        If M.MemInfo.State <> MEM_COMMIT Then
           SubItems.Add('')
        Else begin
             Pom:=M.MemInfo.AllocationProtect;
             Pom:= Pom And Not PAGE_GUARD;
             Pom:= Pom And Not PAGE_NOCACHE;
             S:='';
             If (M.MemInfo.AllocationProtect And PAGE_GUARD > 0) Then
                S:=' [Hldno] ';
             If (M.MemInfo.AllocationProtect And PAGE_NOCACHE > 0) Then
                S:=S+'[Necacheovno]';
             Case Pom Of
                  PAGE_EXECUTE           : SubItems.Add('E'+S);
                  PAGE_EXECUTE_READ      : SubItems.Add('RE'+S);
                  PAGE_EXECUTE_READWRITE : SubItems.Add('RWE'+S);
                  PAGE_EXECUTE_WRITECOPY : SubItems.Add('RWE'+S);
                  PAGE_NOACCESS          : SubItems.Add('dn'+S);
                  PAGE_READONLY          : SubItems.Add('R'+S);
                  PAGE_READWRITE         : SubItems.Add('RW'+S);
                  PAGE_WRITECOPY         : SubItems.Add('W'+S);
                  Else                     SubItems.Add(S);
                  end;
             end;
        end;
     If SloupecDejStav(MEMPAGES_SLOUPEC_ACCESS) Then
        begin
        If M.MemInfo.State <> MEM_COMMIT Then
           SubItems.Add('')
        Else begin
             Pom:=M.MemInfo.Protect;
             Pom:= Pom And Not PAGE_GUARD;
             Pom:= Pom And Not PAGE_NOCACHE;
             S:='';
             If (M.MemInfo.Protect And PAGE_GUARD > 0) Then
                S:=' [Hldno]';
             If (M.MemInfo.Protect And PAGE_NOCACHE > 0) Then
                S:=S+' [Necacheovno]';
             Case Pom Of
                  PAGE_EXECUTE           : SubItems.Add('E'+S);
                  PAGE_EXECUTE_READ      : SubItems.Add('RE'+S);
                  PAGE_EXECUTE_READWRITE : SubItems.Add('RWE'+S);
                  PAGE_EXECUTE_WRITECOPY : SubItems.Add('RWE'+S);
                  PAGE_NOACCESS          : SubItems.Add('dn'+S);
                  PAGE_READONLY          : SubItems.Add('R'+S);
                  PAGE_READWRITE         : SubItems.Add('RW'+S);
                  PAGE_WRITECOPY         : SubItems.Add('W'+S);
                  Else                     SubItems.Add(S);
                  end;
             end;
        end;
     If SloupecDejStav(MEMPAGES_SLOUPEC_TYPE2) Then
        begin
        If M.MemInfo.State <> MEM_COMMIT Then
           SubItems.Add('')
        Else begin
             Case M.MemInfo.Type_9 Of
                  MEM_PRIVATE : SubItems.Add('Privtn');
                  MEM_MAPPED  : SubItems.Add('Namapovan soubor');
                  MEM_IMAGE   : SubItems.Add('Image');
                  Else          SubItems.Add('');
                  end;
             end;
        end;
     If SloupecDejStav(MEMPAGES_SLOUPEC_NAME) Then
        SubItems.Add(M.Name);
     end;
end;

Procedure TMemPages.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
SortStyle:=TMemPagesSortStyle(Column.Tag);
Enumerate;
end;

Procedure TMemPages.ShowContent(Index:Integer);
Var M : PMemPagesRecord;
begin
M:=GetMemPage(Index);
CreateGetObjectContentForm(Application.Handle,Cardinal(M.MemInfo.AllocationBase),HANDLE_TYPE_MEMORY,FPID,Cardinal(M.MemInfo.AllocationBase),M.MemInfo.RegionSize);
end;

End.
