Unit ClassModule;

Interface

Uses Sorting, TlHelp32, ComCtrls;

Const
      MODULY_SLOUPEC_NAME = 0;
      MODULY_SLOUPEC_PATH = 1;
      MODULY_SLOUPEC_BASE = 2;
      MODULY_SLOUPEC_SIZE = 3;
      MODULY_SLOUPEC_REFS = 4;
      MODULY_MAX_SLOUPCU  = 5;

Type
     TModulySortType = (mstNazev, mstCesta, mstAdresa, mstVelikost, mstPocetOdkazu);
     PModuleRecord = ^ModuleEntry32;
     TModuly = Class (TSortList)
               Private
                FSortStyle : TModulySortType;
                FPID       : Cardinal;
               Protected
                Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Override;
                Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Override;
                Procedure SetSortStyle(H:TModulySortType);
               Public
                Constructor Create(AListView:TListView; APID:Cardinal); Reintroduce; Virtual;
                Procedure Enumerate;
                Procedure ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Override;
                Procedure ListViewColumnClick(Sender: TObject; Column: TListColumn); Override;
                Function  GetModule(Index:Integer):PModuleRecord;

                Function Inject(ModuleName:String):Cardinal;
                Function Remove(Index:Integer):Boolean;

                Procedure ShowInfo(Index:Integer);
                Property  SortStyle : TModulySortType Read FSortStyle Write SetSortStyle;
                Property  PID : Cardinal Read FPID;
               end;

Implementation

Uses Windows, SysUtils, OSVersion,
     ModuleOperationImport, ShellAPI,
     ModuleInformationForm, Forms,
     ProceduresImport;

Const
      KRITERIUM_NAZEV       = 0;
      KRITERIUM_CESTA       = 1;
      KRITERIUM_ADRESA      = 2;
      KRITERIUM_VELIKOST    = 3;
      KRITERIUM_POCETODKAZU = 4;

Constructor TModuly.Create(AListView:TListView; APID:Cardinal);
begin
Inherited Create(AListView);
Kriteria.Add(Pointer(KRITERIUM_NAZEV));
SortStyle:=mstNazev;
Opacne:=False;
PocetSloupcu:=MODULY_MAX_SLOUPCU;
FJmena.LoadFromFile(ExtractFilePath(Application.ExeName)+'Data\module.col');
FSortStyle:=mstNazev;
FPID:=APID;
end;

Procedure TModuly.SetSortStyle(H:TModulySortType);
begin
If H = FSortStyle Then
   Opacne:= Not Opacne
Else begin
     Opacne:=False;
     FSortStyle:=H;
     If Kriteria.Count > 1 Then
        Kriteria.Delete(0);
     Case FSortStyle Of
          mstCesta       : Kriteria.Insert(0,Pointer(KRITERIUM_CESTA));
          mstAdresa      : Kriteria.Insert(0,Pointer(KRITERIUM_ADRESA));
          mstVelikost    : Kriteria.Insert(0,Pointer(KRITERIUM_VELIKOST));
          mstPocetOdkazu : Kriteria.Insert(0,Pointer(KRITERIUM_POCETODKAZU));
          end;
     end;
Serad;
end;

Function  TModuly.JeVetsi(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : ^ModuleEntry32;
begin
Result:=False;
X:=A;
Y:=B;
Case K OF
     KRITERIUM_NAZEV       : Result:= AnsiStrComp(PAnsiChar(String(X.szModule)),PAnsiChar(String(Y.szModule))) > 0;
     KRITERIUM_CESTA       : Result:= AnsiStrComp(PAnsiChar(String(X.szExePath)),PAnsiChar(String(Y.szExePath))) > 0;
     KRITERIUM_ADRESA      : Result:= DWORD(X.modBaseAddr) > DWORD(Y.modBaseAddr);
     KRITERIUM_VELIKOST    : Result:= X.modBaseSize > Y.modBaseSize;
     KRITERIUM_POCETODKAZU : Result:= X.ProccntUsage > Y.ProccntUsage;
     end;
end;

Function  TModuly.JeRovno(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : ^ModuleEntry32;
begin
Result:=False;
X:=A;
Y:=B;
Case K OF
     KRITERIUM_NAZEV       : Result:= AnsiStrComp(PAnsiChar(String(X.szModule)),PAnsiChar(String(Y.szModule))) = 0;
     KRITERIUM_CESTA       : Result:= AnsiStrComp(PAnsiChar(String(X.szExePath)),PAnsiChar(String(Y.szExePath))) = 0;
     KRITERIUM_ADRESA      : Result:= DWORD(X.modBaseAddr) = DWORD(Y.modBaseAddr);
     KRITERIUM_VELIKOST    : Result:= X.modBaseSize = Y.modBaseSize;
     KRITERIUM_POCETODKAZU : Result:= X.ProccntUsage = Y.ProccntUsage;
     end;
end;

Function TModuly.GetModule(Index:Integer):PModuleRecord;
begin
Result:=Items[Index];
end;

Procedure TModuly.Enumerate;
Var hSnap : THandle;
    ME    : ModuleEntry32;
    X     : PModuleRecord;
begin
Clear;
hSnap:=ModuleSearchInit(FPID);
If hSnap > 0 Then
   begin
   ME.dwSize:=SizeOf(ME);
   If ModuleSearchFirst(hSnap,ME) Then
      begin
      Repeat
      New(X);
      X^:=ME;
      Add(X);
      Until Not ModuleSearchNext(hSnap,ME);
      end
   Else ErrorMessage('ModuleSearchFirst: '+SysErrorMessage(GetLastError));
   ModuleSearchDestroy(hSnap);
   end
Else ErrorMessage('ModuleSearchInit: '+SysErrorMessage(GetLastError));
Serad;
If Assigned(FListView) Then
   begin
   FListView.Invalidate;
   FListView.Items.Count:=Count;
   end;
end;

Procedure TModuly.ListViewVykresliJednoho(Sender:TObject; Item:TListItem);
Var M : PModuleRecord;
    Zaznam : _SHFILEINFOA;
begin
M:=GetModule(Item.Index);
With Item Do
     begin
     If SloupecDejStav(MODULY_SLOUPEC_NAME) Then
        Caption:=M.szModule;
     If SloupecDejStav(MODULY_SLOUPEC_PATH) Then
        SubItems.Add(ExtractFileDir(M.szExePath));
     If SloupecDejStav(MODULY_SLOUPEC_BASE) Then
        SubItems.Add('$'+IntToHex(Int64(M.modBaseAddr),8));
     If SloupecDejStav(MODULY_SLOUPEC_SIZE) Then
        SubItems.Add(IntToStr(Int64(M.modBaseSize))+' B');
     If SloupecDejStav(MODULY_SLOUPEC_REFS) Then
        SubItems.Add(IntToStr(Int64(M.ProccntUsage)));
     If ShGetFileInfo(PAnsiChar(String(M.szExePath)),0,Zaznam,SizeOf(Zaznam),SHGFI_SMALLICON Or SHGFI_ICON Or SHGFI_SYSICONINDEX) <> 0 Then
        begin
        DestroyIcon(Zaznam.hIcon);
        ImageIndex:=Zaznam.iIcon;
        end;
     end;
end;

Procedure TModuly.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
Enumerate;
SortStyle:=TModulySortType(Column.Tag);
end;

Procedure TModuly.ShowInfo(Index:Integer);
begin
CreateModuleInformationForm(Application.Handle,FPID,GetModule(Index).szExePath,Cardinal(GetModule(Index).modBaseAddr));
end;

Function TModuly.Inject(ModuleName:String):Cardinal;
begin
Result:=InjectModule(FPID,PAnsiChar(ModuleName));
Enumerate;
end;

Function TModuly.Remove(Index:Integer):Boolean;
Var S : String;
begin
Result:=False;
S:=GetModule(Index).szExePath;
If GetModule(Index).ProccntUsage = 65535 Then
   Exit;
While (GetModule(Index).szExePath = S) Do
      begin
      RemoveRemoteModule(FPID,PAnsiChar(S));
      Enumerate;
     end;
Result:=True;
end;

End.
