Unit ClassProcesy;

Interface

Uses Sorting, Windows, ComCtrls,
     PProcImport;

Const
      PROCESY_SLOUPEC_EXEFILE  = 0;
      PROCESY_SLOUPEC_EXEPATH  = 1;
      PROCESY_SLOUPEC_PID      = 2;
      PROCESY_SLOUPEC_ODKAZY   = 3;
      PROCESY_SLOUPEC_PRIORITA = 4;
      PROCESY_SLOUPEC_VLAKNA   = 5;
      PROCESY_SLOUPEC_PARENT   = 6;
      PROCESY_SLOUPEC_HANDLECOUNT = 7;
      PROCESY_SLOUPEC_GDI         = 8;
      PROCESY_SLOUPEC_USER        = 9;
      PROCESY_SLOUPEC_ALLOCMEM    = 10;
      PROCESY_SLOUPEC_RESERVEDMEM = 11;
      PROCESY_SLOUPEC_CELKMEM     = 12;
      PROCESY_MAX_SLOUPCU         = 13;

Type
  TProcessType   = (tpDriver, tpProcess, tpService);
  TSortStyle = (stJmeno, stCesta, stPID,
                stOdkazy, stPriorita,
                stVlakna, stParentProcess,
                stOpenHandles, stGDI,
                stUser, stAllocMem,
                stReservedMem, stCelkMem);

     TProcesy = Class (TSortList)
                Private
                 FSortStyle : TSortStyle;
                 Procedure Win95DejSeznamProcesu;
                 Procedure WinNTDejSeznamProcesu;
                Protected
                 Procedure SetSortStyle(H:TSortStyle);               Virtual;
                 Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Override;
                 Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Override;
                Public
                 Constructor Create(AListview:TListView); Override;
                 Destructor  Destroy; Override;
                 Function    GetProcess(Index:Integer):PProcess;
                 Function    Add(P:PProcess):Integer; Reintroduce; Virtual;
                 Procedure   Enumerate; Virtual;
                 Procedure   ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Override;
                 Procedure   ListViewColumnClick(Sender: TObject; Column: TListColumn); Override;

                 Function  Suspend(Index:Integer):Boolean;
                 Function  Resume(Index:Integer):Boolean;
                 Function  Terminate(Index:Integer):Boolean;
                 Function  OKTerminate(Index:Integer):Boolean;
                 Procedure ShowInfo(Index:Integer);

                 Property SortStyle : TSortStyle Read FSortStyle Write SetSortStyle;
                end;



Implementation

Uses SysUtils, PSAPI, TlHelp32,
     proceduresImport,
     OSVersion,
     Forms,
     ShellAPI,
     ModuleOperationImport,
     ProcessInfoForm;

Const
    KRITERIUM_NAME        = 1;
    KRITERIUM_FILENAME    = 2;
    KRITERIUM_PID         = 3;
    KRITERIUM_CNTUSAGE    = 4;
    KRITERIUM_THREADCOUNT = 5;
    KRITERIUM_HANDLECOUNT = 6;
    KRITERIUM_GDICOUNT    = 7;
    KRITERIUM_USERCOUNT   = 8;
    KRITERIUM_MEMORY      = 9;
    KRITERIUM_PRIORITY    = 10;
    KRITERIUM_RESERVED_MEMORY = 11;
    KRITERIUM_CELKMEMORY  = 13;


Function ProcessEntryToTProcess(PE:ProcessEntry32):TProcess;
begin
With PE Do
     begin
     Result.th32ProcessID:=th32ProcessID;
     Result.th32ParentProcessID:=th32ParentProcessID;
     Result.szExeFile:=szExeFile;
     Result.CntUsage:=CntUsage;
     Result.CntThreads:=CntThreads;
     Result.pcPriClassBase:=pcPriClassBase;
     end;
end;

Function ProcessPriorityToString(Pri:Integer):String;
begin
Result:=IntToStr(Int64(Pri))+' [';
Case Pri Of
     HIGH_PRIORITY_CLASS : Result:=Result+'Vysok]';
     NORMAL_PRIORITY_CLASS : Result:=Result+'Normln]';
     IDLE_PRIORITY_CLASS : Result:=Result+'Nzk]';
     REALTIME_PRIORITY_CLASS : Result:=Result+'Reln as]';
     end;
end;

// TProcesy

Constructor TProcesy.Create(AListView:TListView);
begin
Inherited Create(AListView);
Kriteria.Add(Pointer(KRITERIUM_NAME));
Kriteria.Add(Pointer(KRITERIUM_PID));
FJmena.LoadFromFile('Data\process.col');
PocetSloupcu:=PROCESY_MAX_SLOUPCU;
end;

Destructor TProcesy.Destroy;
begin
Inherited Destroy;
end;

Procedure TProcesy.SetSortStyle(H:TSortStyle);
begin
If H <> FSortStyle Then
   begin
   FSortStyle:=H;
   Opacne:=False;
   end
Else begin
     Opacne:= Not Opacne;
     Serad;
     Exit;
     end;
IF Kriteria.Count > 4 Then
   Kriteria.Delete(0);
Case H OF
     stJmeno       : Kriteria.Insert(0,Pointer(KRITERIUM_NAME));
     stCesta       : Kriteria.Insert(0,Pointer(KRITERIUM_FILENAME));
     stPID         : Kriteria.Insert(0,Pointer(KRITERIUM_PID));
     stPriorita    : Kriteria.Insert(0,Pointer(KRITERIUM_PRIORITY));
     stOdkazy      : Kriteria.Insert(0,Pointer(KRITERIUM_CNTUSAGE));
     stVlakna      : Kriteria.Insert(0,Pointer(KRITERIUM_THREADCOUNT));
     stAllocMem    : Kriteria.Insert(0,Pointer(KRITERIUM_MEMORY));
     stOpenHandles : Kriteria.Insert(0,Pointer(KRITERIUM_HANDLECOUNT));
     stGDI         : Kriteria.Insert(0,Pointer(KRITERIUM_GDICOUNT));
     stUser        : Kriteria.Insert(0,Pointer(KRITERIUM_USERCOUNT));
     stReservedMem : Kriteria.Insert(0,Pointer(KRITERIUM_RESERVED_MEMORY));
     stCelkMem     : Kriteria.Insert(0,Pointer(KRITERIUM_CELKMEMORY));
     end;
Serad;
end;

Function TProcesy.GetProcess(Index:Integer):PProcess;
begin
Result:=Items[Index];
end;

Function  TProcesy.JeVetsi(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : TProcess;
begin
X:=TProcess(A^);
Y:=TProcess(B^);
Result:=False;
Case K OF
     KRITERIUM_NAME        : Result:=AnsiStrComp(PAnsiChar(ExtractFileName(X.szExeFile)),PAnsiChar(ExtractFileName(Y.szExeFile))) > 0;
     KRITERIUM_FILENAME    : Result:=AnsiStrComp(PAnsiChar(X.szExeFile),PAnsiChar(Y.szExeFile)) > 0;
     KRITERIUM_PID         : Result:= X.th32ProcessID  > Y.th32ProcessID;
     KRITERIUM_PRIORITY    : Result:= X.pcPriClassBase > Y.pcPriClassBase;
     KRITERIUM_THREADCOUNT : Result:= X.CntThreads     > Y.CntThreads;
     KRITERIUM_CNTUSAGE    : Result:= X.CntUsage       > Y.CntUsage;
     KRITERIUM_GDICOUNT    : Result:= X.GDIHandles     > Y.GDIHandles;
     KRITERIUM_USERCOUNT   : Result:= X.UserHandles    > Y.UserHandles;
     KRITERIUM_MEMORY      : Result:= X.AllocatedMemory > Y.AllocatedMemory;
     KRITERIUM_HANDLECOUNT : Result:= X.HandleCount    > Y.HandleCount;
     KRITERIUM_RESERVED_MEMORY  : Result:= X.ReservedMemory > Y.ReservedMemory;
     KRITERIUM_CELKMEMORY      : Result:= X.CelkMemory > Y.CelkMemory;
     end;
end;

Function TProcesy.JeRovno(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : TProcess;
begin
X:=TProcess(A^);
Y:=TProcess(B^);
Result:=False;
Case K OF
     KRITERIUM_NAME        : Result:=AnsiStrComp(PAnsiChar(ExtractFileName(X.szExeFile)),PAnsiChar(ExtractFileName(Y.szExeFile))) = 0;
     KRITERIUM_FILENAME    : Result:=AnsiStrComp(PAnsiChar(X.szExeFile),PAnsiChar(Y.szExeFile)) = 0;
     KRITERIUM_PID         : Result:=False;
     KRITERIUM_PRIORITY    : Result:= X.pcPriClassBase = Y.pcPriClassBase;
     KRITERIUM_THREADCOUNT : Result:= X.CntThreads     = Y.CntThreads;
     KRITERIUM_CNTUSAGE    : Result:= X.CntUsage       = Y.CntUsage;
     KRITERIUM_GDICOUNT    : Result:= X.GDIHandles     = Y.GDIHandles;
     KRITERIUM_USERCOUNT   : Result:= X.UserHandles    = Y.UserHandles;
     KRITERIUM_MEMORY      : Result:= X.AllocatedMemory = Y.AllocatedMemory;
     KRITERIUM_HANDLECOUNT : Result:= X.HandleCount    = Y.HandleCount;
     KRITERIUM_RESERVED_MEMORY      : Result:= X.ReservedMemory = Y.ReservedMemory;
     KRITERIUM_CELKMEMORY           : Result:= X.CelkMemory = Y.CelkMemory;
     end;
end;

Function TProcesy.Add(P:PProcess):Integer;
begin
Result:= Inherited Add(P);
end;

Procedure TProcesy.Enumerate;
Var I : Integer;
begin
If Assigned(FListView) Then
   FListview.Items.Count:=0;
Clear;
If WinNT Then
   WinNTDejSeznamProcesu
Else Win95DejSeznamProcesu;
Serad;
If Assigned(FListView) Then
   begin
   FListView.Items.Count:=Count;
   FListview.Invalidate;
   end;
end;

Procedure TProcesy.Win95DejSeznamProcesu;
Var HSnap, hProcess : THandle;
    PE    : ProcessEntry32;
    X : PProcess;
    Zaznam : _SHFILEINFOA;
begin
HSnap:=CreateToolHelp32SnapShot(TH32CS_SNAPPROCESS,0);
If HSnap <> 0 Then
   begin
   PE.dwSize:=SizeOf(PE);
   If Process32First(HSnap,PE) Then
      begin
      Repeat
      New(X);
      X^:=ProcessEntryToTProcess(PE);
      X.dwSize:=-1;
      X.AllocatedMemory:=DejAlokovanouPamet(PE.th32ProcessID);
      X.ReservedMemory:=DejReservovanouPamet(PE.th32ProcessID);
      X.CelkMemory:=X.AllocatedMemory + X.ReservedMemory;
      X.GDIHandles:=DejPocetGDIHandlu(PE.th32ProcessID);
      X.UserHandles:=DejPocetUserHandlu(PE.th32ProcessID);
      If ShGetFileInfo(PAnsiChar(X.szExeFile),0,Zaznam,SizeOf(Zaznam),SHGFI_ICON Or SHGFI_SYSICONINDEX Or SHGFI_SMALLICON) <> 0 Then
         X^.dwSize:=Zaznam.iIcon;
      hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,X.th32ProcessID);
      If hProcess > 0 Then
         begin
         X.pcPriClassBase:=GetPriorityClass(hProcess);
         CloseHandle(hProcess);
         end;
      Add(X);
      Until Not Process32Next(HSnap,PE);
      end;
   CloseHandle(HSnap);
   end;
end;

Procedure TProcesy.WinNTDejSeznamProcesu;
Label Znovu;
Var I : Integer;
    Buffer : String;
    BigArray : Array [0..$3FF-1] Of Cardinal;
    NewCount : Cardinal;
    hProcess : THandle;
    X : PProcess;
    Zaznam : _SHFILEINFOA;
begin
Win95DejSeznamProcesu;
For I:=0 To Count-1 Do
    begin
    X:=GetProcess(I);
    X.HandleCount:=DejPocetHandlu(X.th32ProcessID);
    Buffer:=DejSouborProcesu(X.th32ProcessID);
    If (Buffer <> '') And (X.th32ProcessID <> 0) Then
       X.szExeFile:=Buffer;
    hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,X.th32ProcessID);
    If hProcess > 0 Then
       begin
       X.pcPriClassBase:=GetPriorityClass(hProcess);
       CloseHandle(hProcess);
       end;
    If Pos('\??\',X.szExeFile) = 1 Then
       System.Delete(X.szExeFile,1,4);
    If Pos('\SystemRoot\',X.szExeFile) = 1 Then
       begin
       System.Delete(X.szExeFile,1,12);
       X.szExeFile:='C:\Windows\'+X.szExeFile;
       end;
    If ShGetFileInfo(PAnsiChar(X.szExeFile),0,Zaznam,SizeOf(Zaznam),SHGFI_ICON Or SHGFI_SYSICONINDEX Or SHGFI_SMALLICON) <> 0 Then
       X.dwSize:=Zaznam.iIcon;
    end;
Znovu:
For I:=0 To Count-1 Do
    begin
    If GetProcess(I).szExeFile = '' Then
       begin
       Delete(I);
       Goto Znovu;
       end;
    end;
end;

Procedure TProcesy.ListViewVykresliJednoho(Sender:TObject; Item:TListItem);
Var P : PProcess;
begin
P:=GetProcess(Item.Index);
Item.ImageIndex:=P.dwSize;
Item.Caption:=ExtractFileName(P.szExeFile);
If SloupecDejStav(PROCESY_SLOUPEC_EXEPATH) Then
   Item.SubItems.Add(ExtractFileDir(P.szExeFile));
If SloupecDejStav(PROCESY_SLOUPEC_PID) Then
   Item.SubItems.Add('$'+IntToHex(Int64(P.th32ProcessID),8));
If SloupecDejStav(PROCESY_SLOUPEC_ODKAZY) Then
   Item.SubItems.Add(IntToStr(Int64(P.CntUsage)));
If SloupecDejStav(PROCESY_SLOUPEC_PRIORITA) Then
   Item.SubItems.Add(ProcessPriorityToString(P.pcPriClassBase));
If SloupecDejStav(PROCESY_SLOUPEC_VLAKNA) Then
   Item.SubItems.Add(IntToStr(Int64(P.CntThreads)));
If SloupecDejStav(PROCESY_SLOUPEC_PARENT) Then
   Item.SubItems.Add(ExtractFileName(DejSouborZPID(P.th32ParentProcessID)));
If SloupecDejStav(PROCESY_SLOUPEC_HANDLECOUNT) Then
   Item.SubItems.Add(IntToStr(Int64(P.HandleCount)));
If SloupecDejStav(PROCESY_SLOUPEC_GDI) Then
   Item.SubItems.Add(IntToStr(Int64(P.GDIHandles)));
If SloupecDejStav(PROCESY_SLOUPEC_USER) Then
   Item.SubItems.Add(IntToStr(Int64(P.UserHandles)));
If SloupecDejStav(PROCESY_SLOUPEC_ALLOCMEM) Then
   Item.SubItems.Add(IntToStr(Int64(P.AllocatedMemory Div 1024))+' KB');
If SloupecDejStav(PROCESY_SLOUPEC_RESERVEDMEM) Then
   Item.SubItems.Add(IntToStr(Int64(P.ReservedMemory Div 1024))+' KB');
If SloupecDejStav(PROCESY_SLOUPEC_CELKMEM) Then
   Item.SubItems.Add(IntToStr(Int64(P.CelkMemory Div 1024))+' KB');
end;

Procedure TProcesy.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
Enumerate;
SortStyle:=TSortStyle(Column.Tag);
end;

Function  TProcesy.Suspend(Index:Integer):Boolean;
begin
SuspendProcess(GetProcess(Index).th32ProcessID);
Result:=True;
end;

Function  TProcesy.Resume(Index:Integer):Boolean;
begin
ResumeProcess(GetProcess(Index).th32ProcessID);
Result:=True;
end;

Function  TProcesy.Terminate(Index:Integer):Boolean;
begin
KillProcess(GetProcess(Index).th32ProcessID);
Result:=True;
end;

Function  TProcesy.OKTerminate(Index:Integer):Boolean;
begin
OkTerminateProcess(GetProcess(Index).th32ProcessID);
Result:=True;
end;

Procedure TProcesy.ShowInfo(Index:Integer);
begin
CreateInfoOProcesuForm(Application.Handle,GetProcess(Index));
end;

End.
