Unit ClassSSDT;

Interface

Uses Sorting, ComCtrls, WinNTFunctions;


Const
      SSDT_SLOUPEC_INDEX = 0;
      SSDT_SLOUPEC_NAME = 1;
      SSDT_SLOUPEC_ADDRESS = 2;
      SSDT_SLOUPEC_MODULENAME = 3;
      SSDT_SLOUPEC_OADDRESS = 4;
      SSDT_SLOUPEC_OMODULENAME = 5;
      SSDT_MAX_SLOUPCU = 6;

Type
      TSystemModuleArray = Array [0..1] Of SYSTEM_MODULE_INFORMATION;
      PSystemModuleArray = ^TSystemModuleArray;
      TSysModuleArray = Packed Record
                        Count : ULONG;
                        Modules : TSystemModuleArray;
                        end;
      PSysModuleArray = ^TSysModuleArray;

      TSSDTFunction = Record
                      Index              : Cardinal;
                      Address            : Cardinal;
                      OriginalAddress    : Cardinal;
                      Name               : String;
                      ModuleName         : String;
                      OriginalModuleName : String;
                      end;
      PSSDTFunction = ^TSSDTFunction;
      TSSDTSortStyle = (ssdtIndex, ssdtName,
                        ssdtAddress, ssdtModuleName,
                        ssdtOriginalAddress,
                        ssdtOriginalModuleName);

      TSSDT = Class (TSortList)
              Private
               FSortStyle : TSSDTSortStyle;
               FPole : PSysModuleArray;
              Protected
               Procedure SetSortStyle(H:TSSDTSortStyle);
               Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Override;
               Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Override;
              Public
               Constructor Create(AListview:TListView); Override;
               Procedure Enumerate; Override;
               Procedure   ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Override;
               Function    GetFunc(Index:Integer):PSSDTFunction;
               Procedure   ListViewColumnClick(Sender: TObject; Column: TListColumn); Override;
               Property SortStyle : TSSDTSortStyle Read FSortStyle Write SetSortStyle;
              end;

Implementation

Uses SysUtils, ssdtImport,
     ProceduresImport;

Const
      KRITERIUM_INDEX = 0;
      KRITERIUM_NAME = 1;
      KRITERIUM_ADDRESS = 2;
      KRITERIUM_MODULENAME = 3;
      KRITERIUM_OADDRESS = 4;
      KRITERIUM_OMODULENAME = 5;

Constructor TSSDT.Create(AListview:TListView);
begin
Inherited Create(AListView);
Opacne:=False;
FSortStyle:=ssdtIndex;
Kriteria.Add(Pointer(KRITERIUM_INDEX));
PocetSloupcu:=SSDT_MAX_SLOUPCU;
FJmena.LoadFromFile(ExtractFilePath(ParamStr(0))+'Data\ssdt.col');
end;

Var Slf : TSSDT;
    Size : Cardinal;

Function SSDTFce(DescriptorBase, DispatchBase, FunctionCount, AktFunc, AktFuncAddr : Cardinal; Name:String):Boolean; StdCall;
Var X : PSSDTFunction;
    I : Integer;
    Jmeno, OJmeno : Boolean;
begin
Result:=True;
New(X);
X.Index:=AktFunc;
X.Address:=AktFuncAddr;
X.OriginalAddress:=X.Address;
X.ModuleName:='<Nelze zjistit>';
X.OriginalModuleName:='<Nelze zjistit>';
X.Name:=Name;
If Assigned(Slf.FPole) Then
   begin
   Jmeno:=False;
   OJmeno:=False;
   For I:=0 To Slf.FPole.Count-1 Do
       begin
       If (X.Address > Cardinal(Slf.FPole.Modules[I].Base)) And
          (X.Address < Cardinal(Slf.FPole.Modules[I].Base)+Slf.FPole.Modules[I].Size) Then
          begin
          X.ModuleName:=Slf.FPole.Modules[I].ImageName;
          Jmeno:=True;
          end;
       If (X.OriginalAddress > Cardinal(Slf.FPole.Modules[I].Base)) And
          (X.OriginalAddress < Cardinal(Slf.FPole.Modules[I].Base)+Slf.FPole.Modules[I].Size) Then
          begin
          X.OriginalModuleName:=Slf.FPole.Modules[I].ImageName;
          OJmeno:=True;
          end;
       If (Jmeno) And (OJmeno) Then
          Break;
       end;
   end;
X.ModuleName:=KeModuleNameToFileName(X.ModuleName);
X.OriginalModuleName:=KeModuleNameToFilename(X.OriginalModuleName);
Slf.Add(X);
end;

Procedure TSSDT.Enumerate;
begin
If Assigned(ListView) Then
   Listview.Items.Count:=0;
Clear;
FPole:=Nil;
Size:=0;
GetDeviceDriverList(FPole,Size);
If Size <> 0 Then
   begin
   GetMem(FPole,Size);
   If GetDeviceDriverList(FPole,Size) = STATUS_SUCCESS Then
      begin
      end
   Else begin
        FreeMem(FPole);
        FPole:=Nil;
        end;
   end;
Slf:=Self;
GetSSDT(@SSDTFce);
Serad;
If Assigned(ListView) Then
   begin
   ListView.Items.Count:=Count;
   ListView.Invalidate;
   end;
If Assigned(FPole) Then
   FreeMem(FPole);
end;

Procedure TSSDT.SetSortStyle(H:TSSDTSortStyle);
begin
If H = FSortStyle Then
   begin
   Opacne:= Not Opacne;
   Serad;
   Exit;
   end;
FSortStyle:=H;
Kriteria.Clear;
Kriteria.Add(Pointer(KRITERIUM_INDEX));
Case H Of
     ssdtIndex              : Kriteria.Insert(0,Pointer(KRITERIUM_INDEX));
     ssdtName               : Kriteria.Insert(0,Pointer(KRITERIUM_NAME));
     ssdtAddress            : Kriteria.Insert(0,Pointer(KRITERIUM_ADDRESS));
     ssdtModuleName         : Kriteria.Insert(0,Pointer(KRITERIUM_MODULENAME));
     ssdtOriginalAddress    : Kriteria.Insert(0,Pointer(KRITERIUM_OADDRESS));
     ssdtOriginalModuleName : Kriteria.Insert(0,Pointer(KRITERIUM_OMODULENAME));
     end;
Serad;
end;

Function TSSDT.JeVetsi(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PSSDTFunction;
begin
Result:=False;
X:=A;
Y:=B;
Case K Of
     KRITERIUM_INDEX        : Result:= X.Index > Y.Index;
     KRITERIUM_NAME         : Result:= AnsiStrComp(PAnsiChar(X.Name),PAnsiChar(Y.Name)) > 0;
     KRITERIUM_ADDRESS      : Result:= X.Address > Y.Address;
     KRITERIUM_MODULENAME   : Result:= AnsiStrComp(PAnsiChar(X.ModuleName),PAnsiChar(Y.ModuleName)) > 0;
     KRITERIUM_OADDRESS     : Result:= X.OriginalAddress > Y.OriginalAddress;
     KRITERIUM_OMODULENAME  : Result:= AnsiStrComp(PAnsiChar(X.OriginalModuleName),PAnsiChar(Y.OriginalModuleName)) > 0;
     end;
end;

Function TSSDT.JeRovno(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PSSDTFunction;
begin
Result:=False;
X:=A;
Y:=B;
Case K Of
     KRITERIUM_INDEX        : Result:= X.Index = Y.Index;
     KRITERIUM_NAME         : Result:= AnsiStrComp(PAnsiChar(X.Name),PAnsiChar(Y.Name)) = 0;
     KRITERIUM_ADDRESS      : Result:= X.Address = Y.Address;
     KRITERIUM_MODULENAME   : Result:= AnsiStrComp(PAnsiChar(X.ModuleName),PAnsiChar(Y.ModuleName)) = 0;
     KRITERIUM_OADDRESS     : Result:= X.OriginalAddress = Y.OriginalAddress;
     KRITERIUM_OMODULENAME  : Result:= AnsiStrComp(PAnsiChar(X.OriginalModuleName),PAnsiChar(Y.OriginalModuleName)) = 0;
     end;
end;

Procedure TSSDT.ListViewVykresliJednoho(Sender:TObject; Item:TListItem);
Var S : PSSDTFunction;
begin
S:=GetFunc(Item.Index);
With Item Do
     begin
     Caption:='$'+IntToHex(Int64(S.Index),2);
     If SloupecDejStav(SSDT_SLOUPEC_NAME) Then
        SubItems.Add(S.Name);
     If SloupecDejStav(SSDT_SLOUPEC_ADDRESS) Then
        SubItems.Add('$'+IntToHex(Int64(S.Address),8));
     If SloupecDejStav(SSDT_SLOUPEC_MODULENAME) Then
        SubItems.Add(S.ModuleName);
     If SloupecDejStav(SSDT_SLOUPEC_OADDRESS) Then
        SubItems.Add('$'+IntToHex(Int64(S.OriginalAddress),8));
     If SloupecDejStav(SSDT_SLOUPEC_OMODULENAME) Then
        SubItems.Add(S.OriginalModuleName);
     end;
end;

Procedure TSSDT.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
SortStyle:=TSSDTSortStyle(Column.Tag);
Enumerate;
end;

Function TSSDT.GetFunc(Index:Integer):PSSDTFunction;
begin
Result:= Items[Index];
end;

End.
