Unit ClassTokeny;

Interface

Uses Sorting, ComCtrls, Windows;

Const
      TOKENY_SLOUPEC_NAME   = 0;
      TOKENY_SLOUPEC_STATUS = 1;
      TOKENY_MAX_SLOUPCU    = 2;

Type
      TTokenRecord = Record
                     Name   : String;
                     Status : Cardinal;
                     end;
      PTokenRecord = ^TTokenRecord;
      TTokenSortStyle = (tssName, tssStatus);

      TTokeny   = Class (TSortList)
                  Private
                   FID     : Cardinal;
                   FThread : Boolean;
                   FSortStyle : TTokenSortStyle;
                  Protected
                   Procedure SetSortStyle(h:TTokenSortStyle); Reintroduce;
                   Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Override;
                   Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Override;
                   Procedure ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Override;
                   Procedure ListViewColumnClick(Sender: TObject; Column: TListColumn); Override;
                  Public
                   Constructor Create(AListView:TListview; AThread:Boolean; AID:Cardinal); Reintroduce; Virtual;
                   Procedure Enumerate; Override;
                   Function GetPriv(Index:Integer):PTokenRecord;
                   Property ID : Cardinal    Read FID;
                   Property Thread : Boolean Read FThread;
                   Property SortStyle : TTokenSortStyle Read FSortStyle Write SetSortStyle;
                  end;

Implementation

Uses SysUtils, TProcImport,
     ProceduresImport;

Const KRITERIUM_NAME   = 0;
      KRITERIUM_STATUS = 1;

Constructor TTokeny.Create(AListView:TListview; AThread:Boolean; AID:Cardinal);
begin
Inherited Create(AListView);
Opacne:=False;
Kriteria.Add(Pointer(KRITERIUM_NAME));
FSortStyle:=tssName;
PocetSloupcu:=TOKENY_MAX_SLOUPCU;
FJmena.LoadFromFile(ExtractFilePath(ParamStr(0))+'Data\token.col');
FID:=AID;
FThread:=AThread;
end;

Procedure TTokeny.SetSortStyle(h:TTokenSortStyle);
begin
If H = FSortStyle Then
   begin
   Opacne:= Not Opacne;
   Serad;
   Exit;
   end;
Kriteria.Clear;
Kriteria.Add(Pointer(KRITERIUM_NAME));
FSortStyle:=H;
Opacne:=False;
Case H Of
     tssName   : Kriteria.Insert(0,Pointer(KRITERIUM_NAME));
     tssStatus : Kriteria.Insert(0,Pointer(KRITERIUM_STATUS));
     end;
Serad;
end;

Function TTokeny.JeVetsi(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PTokenRecord;
begin
X:=A;
Y:=B;
Case K Of
     KRITERIUM_NAME : Result:= AnsiStrComp(PAnsiChar(X.Name),PAnsiChar(Y.Name)) > 0;
     KRITERIUM_STATUS : Result:= X.Status > Y.Status;
     end;
end;

Function TTokeny.JeRovno(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PTokenRecord;
begin
X:=A;
Y:=B;
Case K Of
     KRITERIUM_NAME   : Result:= AnsiStrComp(PAnsiChar(X.Name),PAnsiChar(Y.Name)) = 0;
     KRITERIUM_STATUS : Result:= X.Status = Y.Status;
     end;
end;

Function TTokeny.GetPriv(Index:Integer):PTokenRecord;
begin
Result:= Items[Index];
end;

Procedure TTokeny.Enumerate;
Var X : PTokenRecord;
    hToken : Cardinal;
    hProcess, hThread : Cardinal;
    Buffer : ^TOKEN_PRIVILEGES;
    Size    : Cardinal;
    Buffer2 : PAnsiChar;
    S       : String;
    I       : Integer;
begin
If Assigned(ListView) Then
   Listview.Items.Count:=0;
Clear;
hToken:=0;
If FThread Then
   begin
   hThread:=UniversalOpenThread(THREAD_QUERY_INFORMATION,False,FID);
   If hThread > 0 Then
      begin
      If Not OpenThreadToken(hThread,TOKEN_QUERY,True,hToken) Then
         ErrorMessage('OpenThreadToken: '+SysErrorMessage(GetLastError));
      CloseHandle(hThread);
      end
   Else ErrorMessage('UniversalOpenThread: '+SysErrorMessage(GetLastError));
   end
Else begin
     hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,FID);
     If hProcess > 0 Then
        begin
        If Not OpenProcessToken(hProcess,TOKEN_QUERY,hToken) Then
           ErrorMessage('OpenProcessToken: '+SysErrorMessage(GetLastError));
        CloseHandle(hProcess);
        end
     Else ErrorMessage('OpenProcess: '+SysErrorMessage(GetLastError));
     end;
If hToken = 0 Then
   Exit;
GetMem(Buffer,65535);
If GetTokenInformation(hToken,TokenPrivileges,Buffer,65535,Size) Then
   begin
   For I:=0 To Buffer.PrivilegeCount-1 Do
       begin
       New(X);
       X.Status:=Buffer.Privileges[I].Attributes;
       Buffer2:=StrAlloc(MAX_PATH);
       Size:=MAX_PATH;
       If LookupPrivilegeName(Nil,Buffer.Privileges[I].Luid,Buffer2,Size) Then
          begin
          S:=Copy(String(Buffer2),1,StrLen(Buffer2));
          X.Name:=S;
          end;
       StrDispose(Buffer2);
       Add(X);
       end;
   end;
FreeMem(Buffer);
Serad;
If Assigned(ListView) Then
   begin
   ListView.Items.Count:=Count;
   ListView.Invalidate;
   end;
CloseHandle(hToken);
end;

Procedure TTokeny.ListViewVykresliJednoho(Sender:TObject; Item:TListItem);
Var T : PTokenRecord;
    S : String;
begin
T:=GetPriv(Item.Index);
With Item Do
     begin
     Caption:=T.Name;
     If SloupecDejStav(TOKENY_SLOUPEC_STATUS) Then
        begin
        S:='';
        If (T.Status And SE_PRIVILEGE_ENABLED > 0) Then
           S:=' Povoleno '
        Else S:=' Zakzno ';
        If (T.Status And SE_PRIVILEGE_ENABLED_BY_DEFAULT > 0) Then
           S:=S+' (zkladn) ';
        SubItems.Add(S);
        end;
     end;
end;

Procedure TTokeny.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
SortStyle:=TTokenSortStyle(Column.Tag);
Enumerate;
end;

End.
