Unit bplModuleOperation;


Interface

Uses Windows, Classes, TlHelp32;

Function  RemoveRemoteModule(PID:Cardinal; ModuleName:PChar):Boolean;         StdCall;
Function  InjectModule(PID:Cardinal; ModuleName:PChar):THandle;               StdCall;
Function  GetProcList(ModuleName:String):TStringList;                         StdCall;
Function  GetRemoteModuleHandle(PID:Cardinal; ModuleName:PChar):HMODULE;      StdCall;
Procedure OkTerminateProcess(PID:Cardinal);                                   StdCall;
Function  GetImportListByModuleName(ModuleName:String):TStringList;           StdCall;
Function  GetImportListByModuleBaseAddr(Base,PID:Cardinal):TStringList;       StdCall;
Function  GetExportListByModuleBaseAddr(Base,PID:Cardinal):TStringList; StdCall;

Function  ModuleSearchInit(PID:Cardinal):Cardinal;                            StdCall;
Function  ModuleSearchFirst(hSearch:THandle; Var ME:ModuleEntry32):Boolean;   StdCall;
Function  ModuleSearchNext(hSearch:THandle; Var ME:ModuleEntry32):Boolean;    StdCall;
Procedure ModuleSearchDestroy(hSearch:THandle); StdCall;

Implementation

Uses JclPEImage,
     SysUtils,
     OSVersion,
     ImageHlp,
     PSAPI,
     Win95Functions,
     WinNTFunctions,
     ProceduresImport,
     SSDTImport;

Function  _GetImportListByModuleBaseAddr(Base,PID:Cardinal):TStringList; Forward;

Procedure OkTerminateProcess(PID:Cardinal);
Var hProcess : THandle;
    hThread : THandle;
    A : Pointer;
    TID : Cardinal;
begin
If WinNT Then
   begin
   hProcess:=OpenProcess(PROCESS_CREATE_THREAD,False,PID);
   If hProcess > 0 Then
      begin
      A:=GetProcAddress(GetModuleHandle('KERNEL32.DLL'),'ExitProcess');
      hThread:=CreateRemoteThread(hProcess,Nil,0,A,Nil,0,TID);
      WaitForSingleObject(hThread,INFINITE);
      CloseHandle(hProcess);
      end;
   end
Else If Win98 Then
        Win98TerminateProcess(PID);
end;

Function  RemoveRemoteModule(PID:Cardinal; ModuleName:PChar):Boolean;
Var HKernel, HProcess, HThread, HModule : THandle;
    Addr, A : Pointer;
    Written, TID, Vysledek : Cardinal;
begin
Result:=False;
If WinNT Then
   begin
   HModule:=GetRemoteModuleHandle(PID,ModuleName);
   If HModule = 0 Then
      Exit;
   HKernel:=GetModuleHandle('Kernel32.dll');
   If HKernel > 0 Then
      begin
      HProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_CREATE_THREAD Or PROCESS_VM_WRITE,False,PID);
      If HProcess > 0 Then
         begin
         Addr:=VirtualAllocEx(HProcess,Nil,SizeOf(HModule),MEM_COMMIT,PAGE_EXECUTE_READWRITE);
         If Addr <> Nil Then
            begin
            Windows.WriteProcessMemory(HProcess,Addr,@HModule,SizeOf(HModule),Written);
            If Written = SizeOf(HModule) Then
               begin
               A:=Windows.GetProcAddress(HKernel,'FreeLibrary');
               If A <> Nil Then
                  begin
                  HThread:=Windows.CreateRemoteThread(HProcess,Nil,0,A,Pointer(HMODULE),0,TID);
                  WaitForSingleObject(HThread,INFINITE);
                  Windows.GetExitCodeThread(HThread, Vysledek);
                  Result:=Boolean(Vysledek);
                  CloseHandle(HThread);
                  end;
               end;
            VirtualFreeEx(HProcess,Addr,SizeOf(HMODULE),MEM_DECOMMIT);
            end;
         CloseHandle(HProcess);
         end;
      end;
   end
Else If Win98 Then
        begin
        HModule:=Win95GetRemoteModuleHandle(PID,ModuleName);
        If HModule = 0 Then
           Exit;
        Win98RemoveModule(PID,Pointer(HModule));
        Result:=True;
        end;
end;

Function  GetRemoteModuleHandle(PID:Cardinal; ModuleName:PChar):HMODULE;
Var HKernel, HProcess, HThread : THandle;
    Addr, A : Pointer;
    Written, TID : Cardinal;
begin
Result:=0;
If WinNT Then
   begin
   HKernel:=GetModuleHandle('Kernel32.dll');
   If HKernel > 0 Then
      begin
      HProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_CREATE_THREAD Or PROCESS_VM_WRITE,False,PID);
      If HProcess > 0 Then
   	     begin
   	     Addr:=VirtualAllocEx(HProcess,Nil,Length(ModuleName),MEM_COMMIT,PAGE_EXECUTE_READWRITE);
   	     If Addr <> Nil Then
            begin
            Windows.WriteProcessMemory(HProcess,Addr,ModuleName,Length(ModuleName),Written);
            If Written = Cardinal(Length(ModuleName)) Then
         	     begin
               A:=GetProcAddress(HKernel,'GetModuleHandleA');
               If A <> Nil Then
                  begin
                  HThread:=Windows.CreateRemoteThread(HProcess,Nil,0,A,Addr,0,TID);
                  WaitForSingleObject(HThread,INFINITE);
                  GetExitCodeThread(HThread, hMODULE(Result));
                  CloseHandle(HThread);
                  end;
               end;
            VirtualFreeEx(HProcess,Addr,Length(ModuleName),MEM_DECOMMIT);
            end;
         CloseHandle(HProcess);
         end;
      end;
   end
Else If Win9xMe Then
        Result:=Win95GetRemoteModuleHandle(PID,ModuleName);
end;

Function  InjectModule(PID:Cardinal; ModuleName:PChar):THandle;
Var HProcess, HThread, HKernel : THandle;
    Addr, A : Pointer;
    TID, Written : Cardinal;
begin
Result:=INVALID_HANDLE_VALUE;
If WinNT Then
   begin
   HKernel:=GetModuleHandle('Kernel32.dll');
   If HKernel > 0 Then
      begin
      HProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_CREATE_THREAD Or PROCESS_VM_WRITE,False,PID);
      If HProcess > 0 Then
   	     begin
         Addr:=VirtualAllocEx(HProcess,Nil,Length(ModuleName),MEM_COMMIT,PAGE_EXECUTE_READWRITE);
         If Addr <> Nil Then
            begin
      	    Windows.WriteProcessMemory(HProcess,Addr,ModuleName,Length(ModuleName),Written);
      	    If Written = Cardinal(Length(ModuleName)) Then
               begin
               A:=GetProcAddress(HKernel,'LoadLibraryA');
               If Assigned(A) Then
                  begin
                  HThread:=Windows.CreateRemoteThread(HProcess,Nil,0,A,Addr,0,TID);
                  WaitForSingleObject(HThread,INFINITE);
                  GetExitCodeThread(HThread, DWORD(Result));
                  CloseHandle(HThread);
                  end;
               end;
            VirtualFreeEx(HProcess,Addr,Length(ModuleName),MEM_DECOMMIT);
            end;
         CloseHandle(HProcess);
         end;
      end;
   end
Else If Win98 Then
        Result:=Win98InjectModule(PID,ModuleName);
end;

Function  GetProcList(ModuleName:String):TStringList;
Type
  TDWordArray = array [0..$FFFFF] of DWORD;
Var
  ImageInfo        : LoadedImage;
  pExportDirectory : PImageExportDirectory;
  DirSize          : Cardinal;
  pDummy           : PImageSectionHeader;
  I                : Cardinal;
  pNameRVAs        : ^TDWordArray;
  Name             : String;
begin
Result:=TStringList.Create;
Result.Clear;
If MapAndLoad(PChar(ModuleName),Nil,@ImageInfo,True,True) Then
   begin
   Try
    Try
     pExportDirectory:=ImageDirectoryEntryToData(imageinfo.MappedAddress,False, IMAGE_DIRECTORY_ENTRY_EXPORT, dirsize);
     If (pExportDirectory <> nil) Then
        begin
        pNameRVAs:=ImageRvaToVa(imageinfo.FileHeader, imageinfo.MappedAddress,DWORD(pExportDirectory^.AddressOfNames), pDummy);
        For I:=0 To pExportDirectory^.NumberOfNames-1 Do
            begin
            Name:=PChar(ImageRvaToVa(imageinfo.FileHeader,imageinfo.MappedAddress,pNameRVAs^[i], pDummy));
            Result.Add(Name);
            end;
        end;
   Finally
    UnMapAndLoad(@imageinfo);
    end;
  Except
   Result.Clear;
   end;
  end;
end;

Function  GetExportListByModuleBaseAddr(Base,PID:Cardinal):TStringList; StdCall;
Var NewBase  : Cardinal;
    hSnap    : THandle;
    ME       : ModuleEntry32;
    Buffer   : Pointer;
    hProcess : THandle;
    Read     : Cardinal;
    Size     : Cardinal;
    Status   : NTSTATUS;
    JclPEImage : TJclPeImage;
    JclExports : TJclPeExportFuncList;
    I : Integer;
begin
Buffer:=Nil;
NewBase:=0;
Result:=Nil;
If (Base < $80000000) And (PID <> GetCurrentProcessID) Then
   begin
   // User-mode module
   hSnap:=ModuleSearchInit(PID);
   If hSnap > 0 Then
      begin
      If ModuleSearchFirst(hSnap,ME) Then
         begin
         Repeat
         If (ME.modBaseAddr = Pointer(Base)) Then
            begin
            Buffer:=VirtualAlloc(Nil,ME.modBaseSize,MEM_COMMIT,PAGE_READWRITE);
            If Assigned(Buffer) Then
               begin
               hProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_READ,False,PID);
               If hProcess > 0 Then
                  begin
                  If ReadProcessMemory(hProcess,ME.modBaseAddr,Buffer,ME.modBaseSize,Read) Then
                     NewBase:=Cardinal(Buffer)
                  Else begin
                       CloseHandle(hProcess);
                       VirtualFree(Buffer,ME.modBaseSize,MEM_RELEASE);
                       ModuleSearchDestroy(hSnap);
                       ErrorMessage('ReadProcessMemory: '+SysErrorMessage(GetLastError));
                       Exit;
                       end;
                  CloseHandle(hProcess);
                  end
               Else begin
                    ErrorMessage('OpenProcess: '+SysErrorMessage(GetLastError));
                    VirtualFree(Buffer,ME.modBaseSize,MEM_RELEASE);
                    ModuleSearchDestroy(hSnap);
                    Exit;
                    end;
               Break;
               end
            Else begin
                 ErrorMessage('VirtualAlloc: '+SysErrorMessage(GetLastError));
                 ModuleSearchDestroy(hSnap);
                 Exit;
                 end;
            end;
         Until Not ModuleSearchNext(hSnap,ME);
         If NewBase = 0 Then
            begin
            ErrorMessage('Module nenalezen!');
            ModuleSearchDestroy(hSnap);
            Exit;
            end;
         Base:=NewBase;
         end;
      ModuleSearchDestroy(hSnap);
      end
   Else begin
        ErrorMessage('ModuleSearchInit: '+SysErrorMessage(GetLastError));
        Exit;
       end;
   end
Else If Base >= $80000000 Then
        begin
        // Kernel module
        Size:=PID;
        Buffer:=VirtualAlloc(Nil,PID,MEM_COMMIT,PAGE_EXECUTE_READWRITE);
        ME.modBaseSize:=PID;
        If Assigned(Buffer) Then
           begin
           Status:=GetKernelMemory(Base,PID,Buffer);
           PID:=Size;
           If Status = STATUS_SUCCESS Then
              Base:=Cardinal(Buffer)
           Else begin
                ErrorMessage(IntToHex(Int64(Status),8));
                VirtualFree(Buffer,PID,MEM_RELEASE);
                Exit;
                end;
           end
        Else begin
             ErrorMessage('VirtualAlloc: '+SysErrorMessage(GetLastError));
             Exit;
             end;
        end;
Result:=TStringList.Create;
JclPeImage:=TJclPeImage.Create;
JclPeImage.AttachLoadedModule(Base);
JclExports:=TJclPeExportFuncList.Create(JclPeImage);
For I:=0 To JclExports.FunctionCount-1 Do
    Result.Add(JclExports.Items[I].Name+'**'+IntToStr(Cardinal(JclExports.Items[I].Address))+'**'+IntToStr(Int64(JclExports.Items[I].Ordinal)));
JclExports.Free;
JclPeImage.Free;
If Assigned(Buffer) Then
   VirtualFree(Buffer,ME.modBaseSize,MEM_RELEASE);
end;

Function  GetImportListByModuleName(ModuleName:String):TStringList;
Var JCLImage, JCLImage2 : TJCLPEImage;
    JCLImports : TJCLPEImportList;
    JCLExports : TJCLPeExportFuncList;
    I, J : Integer;
    S : String;
    Addr : Cardinal;
begin
Result:=TStringList.Create;
JCLImage:=TJclPEImage.Create;
JCLImage.FileName:=ModuleName;
JCLImports:=TJclPEImportList.Create(JCLImage);
JCLImage2:=TJCLPEImage.Create;
For I:=0 To JCLImports.AllItemCount-1 Do
    begin
    Addr:=0;
    JCLImage2.FileName:=JCLImports.AllItems[I].ImportLib.FileName;
    JCLExports:=TJCLPeExportFuncList.Create(JCLImage2);
    For J:=0 To JCLExports.Count-1 Do
        begin
        If JCLExports.Items[J].Name = JCLImports.AllItems[I].Name Then
           begin
           Addr:=JCLExports.Items[J].Address;
           Break;
           end;
        end;
    JCLExports.Free;
    S:=JCLImports.AllItems[I].Name+';;'+IntToStr(Int64(JclImports.AllItems[I].Ordinal))+';;'+JclImports.AllItems[I].ImportLib.FileName+';;'+IntToStr(Int64(Addr));
    Result.Add(s);
    end;
JCLImage2.Free;
JCLImports.Free;
JCLImage.Free;
end;

Function  GetImportListByModuleBaseAddr(Base,PID:Cardinal):TStringList;
begin
Result:=_GetImportListByModuleBaseAddr(Base,PID);
end;

Function  _GetImportListByModuleBaseAddr(Base,PID:Cardinal):TStringList;
Var JCLImage, JCLImage2 : TJCLPEImage;
    JCLImports : TJCLPEImportList;
    JCLExports : TJCLPeExportFuncList;
    I, J : Integer;
    S : String;
    Addr : Cardinal;
    ME : ModuleEntry32;
    hSnap : THandle;
    NewBase : Cardinal;
    hProcess : THandle;
    Buffer   : Pointer;
    Read     : Cardinal;
    Status   : Cardinal;
    Size     : Cardinal;
begin
NewBase:=0;
Result:=Nil;
If Base < $80000000 Then
   begin
   // User-mode module
   hSnap:=ModuleSearchInit(PID);
   If hSnap > 0 Then
      begin
      If ModuleSearchFirst(hSnap,ME) Then
         begin
         Repeat
         If (ME.modBaseAddr = Pointer(Base)) Then
            begin
            Buffer:=VirtualAlloc(Nil,ME.modBaseSize,MEM_COMMIT,PAGE_READWRITE);
            If Assigned(Buffer) Then
               begin
               hProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_READ,False,PID);
               If hProcess > 0 Then
                  begin
                  If ReadProcessMemory(hProcess,ME.modBaseAddr,Buffer,ME.modBaseSize,Read) Then
                     NewBase:=Cardinal(Buffer)
                  Else begin
                       CloseHandle(hProcess);
                       VirtualFree(Buffer,ME.modBaseSize,MEM_RELEASE);
                       ModuleSearchDestroy(hSnap);
                       ErrorMessage('ReadProcessMemory: '+SysErrorMessage(GetLastError));
                       Exit;
                       end;
                  CloseHandle(hProcess);
                  end
               Else begin
                    ErrorMessage('OpenProcess: '+SysErrorMessage(GetLastError));
                    VirtualFree(Buffer,ME.modBaseSize,MEM_RELEASE);
                    ModuleSearchDestroy(hSnap);
                    Exit;
                    end;
               Break;
               end
            Else begin
                 ErrorMessage('VirtualAlloc: '+SysErrorMessage(GetLastError));
                 ModuleSearchDestroy(hSnap);
                 Exit;
                 end;
            end;
         Until Not ModuleSearchNext(hSnap,ME);
         If NewBase = 0 Then
            begin
            ErrorMessage('Module nenalezen!');
            ModuleSearchDestroy(hSnap);
            Exit;
            end;
         Base:=NewBase;
         end;
      ModuleSearchDestroy(hSnap);
      end
   Else begin
        ErrorMessage('ModuleSearchInit: '+SysErrorMessage(GetLastError));
        Exit;
       end;
   end
Else If Base >= $80000000 Then
        begin
        // Kernel module
        Size:=PID;
        Buffer:=VirtualAlloc(Nil,PID,MEM_COMMIT,PAGE_EXECUTE_READWRITE);
        ME.modBaseSize:=PID;
        If Assigned(Buffer) Then
           begin
           Status:=GetKernelMemory(Base,PID,Buffer);
           PID:=Size;
           If Status = STATUS_SUCCESS Then
              Base:=Cardinal(Buffer)
           Else begin
                ErrorMessage(IntToHex(Int64(Status),8));
                VirtualFree(Buffer,PID,MEM_RELEASE);
                Exit;
                end;
           end
        Else begin
             ErrorMessage('VirtualAlloc: '+SysErrorMessage(GetLastError));
             Exit;
             end;
        end;
Result:=TStringList.Create;
JCLImage:=TJclPEImage.Create;
JCLImage.AttachLoadedModule(Base);
JCLImports:=TJCLPEImportList.Create(JCLImage);
If JCLImports.AllItemCount = 0 Then
   JCLImports.MakeBorlandImportTableForMappedImage;
JCLImports.TryGetNamesForOrdinalImports;
JCLImage2:=TJCLPEImage.Create;
For I:=0 To JCLImports.AllItemCount-1 Do
    begin
    Addr:=0;
    JCLImage2.FileName:=JCLImports.AllItems[I].ImportLib.FileName;
    JCLExports:=TJCLPeExportFuncList.Create(JCLImage2);
    For J:=0 To JCLExports.Count-1 Do
        begin
        If JCLExports.Items[J].Name = JCLImports.AllItems[I].Name Then
           begin
           Addr:=JCLExports.Items[J].Address;
           Break;
           end;
        end;
    JCLExports.Free;
    S:=JCLImports.AllItems[I].Name+';;'+IntToStr(Int64(JclImports.AllItems[I].Ordinal))+';;'+JclImports.AllItems[I].ImportLib.FileName+';;'+IntToStr(Int64(Addr));
    Result.Add(s);
    end;
JCLImage2.Free;
JCLImports.Free;
JCLImage.Free;
VirtualFree(Buffer,ME.modBaseSize,MEM_RELEASE);
end;

Type
      TPoleModulu = Array [0..65538] Of Cardinal;
      // 0000h - ID procesu
      // 0004h - poet modul
      // 0008h - akt modul
      // ....  - base addr. modul

      PPoleModulu = ^TPoleModulu;

Function  ModuleSearchInit(PID:Cardinal):Cardinal;
Var P        : PPoleModulu;
    Needed   : Cardinal;
    hProcess : THandle;
begin
Result:=0;
If Win9xMe Or WinXP Then
   Result:=Win95ModuleSearchInit(PID)
Else begin
     hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,PID);
     If hProcess > 0 Then
        begin
        P:=New(PPoleModulu);
        If Not EnumProcessModules(hProcess,Pointer(Cardinal(P)+12),SizeOf(TPoleModulu)-12,Needed) Then
               begin
               Dispose(P);
               Exit;
               end;
        P[0]:=PID;
        P[1]:=Needed Div SizeOf(Cardinal);
        P[2]:=0;
        Result:=Cardinal(P);
        CloseHandle(hProcess);
        end;
     end;
end;

Function  ModuleSearchFirst(hSearch:THandle; Var ME:ModuleEntry32):Boolean;
Var P : PPoleModulu;
    hProcess : THandle;
    Buffer   : PAnsiChar;
    BufSize  : Cardinal;
    MBase    : Cardinal;
    S        : String;
begin
Result:=False;
ME.dwSize:=SizeOf(ME);
If Win9xMe Or WinXP Then
   Result:=Win95ModuleSearchFirst(hSearch,ME)
Else begin
     PPoleModulu(hSearch)[2]:=0;
     Result:=ModuleSearchNext(hSearch,ME);
     end;
end;

Function  ModuleSearchNext(hSearch:THandle; Var ME:ModuleEntry32):Boolean;
Var P : PPoleModulu;
    hProcess : THandle;
    MBase    : Cardinal;
    Buffer   : PAnsiChar;
    BufSize  : Cardinal;
begin
Result:=False;
If Win9xMe Or WinXP Then
   Result:=Win95ModuleSearchNext(hSearch,ME)
Else begin
     P:=PPoleModulu(hSearch);
     If P[2] >= P[1] Then
        Exit;
     MBase:=P[P[2]+3];
     hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,P[0]);
     If hProcess > 0 Then
        begin
        ME.modBaseAddr:=PByte(MBase);
        ME.th32ProcessID:=P[0];
        ME.th32ModuleID:=0;
        ME.GlblcntUsage:=0;
        ME.ProccntUsage:=0;
        ME.szExePath:='';
        BufSize:=MAX_PATH;
        Buffer:=StrAlloc(BufSize);
        If GetModuleFileNameEx(hProcess,MBase,Buffer,BufSize) > 0 Then
           begin
           StrCopy(@ME.szExePath,Buffer);
           end
        Else StrDispose(Buffer);
        Result:=True;
        CloseHandle(hProcess);
        Inc(P[2]);
        end;
     end;
end;

Procedure  ModuleSearchDestroy(hSearch:THandle); StdCall;
begin
If (Win9xMe Or WinXP) Then
   CloseHandle(hSearch)
Else Dispose(PPoleModulu(hSearch));
end;

End.
