Unit ProcMain;

Interface

Uses Windows, TlHelp32, ProceduresImport;

Type
    TMemoryCallBack = Function (Mem:_MEMORY_BASIC_INFORMATION):Boolean; StdCall;

Function  ProcessTimes(PID:Cardinal; Var Created,Exited:TDateTime; Var Kernel,User:Int64):Boolean;  StdCall;
Procedure ZaregistrujJakoSluzbu(PID:Cardinal); StdCall;
Procedure Odregistruj(PID:Cardinal);           StdCall;
Function  LzeCistPamet(PID:Cardinal):Boolean;        StdCall;
Function  NactiPametProcesu(PID:Cardinal; Odkud,Kam:Pointer; Pocet:Cardinal; Var Readed:Cardinal):Cardinal; StdCall;
Function  DejPocetHandlu(PID:Cardinal):Int64; StdCall;
Function  DejPocetGDIHandlu(PID:Cardinal):Int64; StdCall;
Function  DejPocetUserHandlu(PID:Cardinal):Int64; StdCall;
Function  DejAlokovanouPamet(PID:Cardinal):Int64; StdCall;
Function  DejReservovanouPamet(PID:Cardinal):Int64; StdCall;
Function  DejSouborZPID(PID:Cardinal):String; StdCall;
Function  DejRodiceVlakna(TID:Cardinal):Cardinal; StdCall;
Function  DejSouborZTID(TID:Cardinal):String; StdCall;
Procedure SuspendProcess(PID:Cardinal); StdCall;
Procedure ResumeProcess(PID:Cardinal); StdCall;
Procedure KillProcess(PID:Cardinal); StdCall;
Procedure RunProcess(ProcessFileName:String); StdCall;
Function  DejSouborProcesu(APID:Cardinal):String; StdCall;
Function  ProcessSearchInit:THandle;                                          StdCall;
Function  ProcessSearchFirst(hSearch:THandle; Var PE:ProcessEntry32):Boolean; StdCall;
Function  ProcessSearchNext(hSearch:THandle; Var PE:ProcessEntry32):Boolean;  StdCall;
Procedure ProcessSearchDestroy(hSearch:THandle); StdCall;                    StdCall;
Procedure DejOblastiPametiProcesu(PID:Cardinal; CallBack:TMemoryCallBack);   StdCall;
Function QueryProcessTimes(PID:Cardinal; Var Create,Exit:TDateTime; Var User,Kernel:Int64):Boolean; StdCall;

implementation

Uses OSVersion,
     SysUtils,
     Win95Functions,
     WinNTFunctions,
     TProcImport,
     HandlesImport,
     SSDTImport;

Const
   RSP_SIMPLE_SERVICE = 1;
   RSP_UNREGISTER_SERVICE = 0;

Function  DejAlokovanouPamet(PID:Cardinal):Int64;
Var hProcess : THandle;
    Mem : _MEMORY_BASIC_INFORMATION;
    Addr : Pointer;
begin
hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,PID);
If hProcess > 0 Then
   begin
   Result:=0;
   Addr:=Nil;
   While VirtualQueryEx(hProcess,Addr,Mem,SizeOf(Mem)) > 0 Do
         begin
         Addr:=Pointer(DWORD(Addr)+Mem.RegionSize);
         If (Mem.State = MEM_COMMIT) Then
            begin
            If DWORD(Addr) < $80000000 Then
               Inc(Result,Mem.RegionSize);
            end;
         end;
   CloseHandle(hProcess);
   end
Else Result:=-1;
end;

Function  DejReservovanouPamet(PID:Cardinal):Int64;
Var hProcess : THandle;
    Mem : _MEMORY_BASIC_INFORMATION;
    Addr : Pointer;
begin
hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,PID);
If hProcess > 0 Then
   begin
   Result:=0;
   Addr:=Nil;
   While VirtualQueryEx(hProcess,Addr,Mem,SizeOf(Mem)) > 0 Do
         begin
         Addr:=Pointer(DWORD(Addr)+Mem.RegionSize);
         If (Mem.State = MEM_RESERVE) Then
            begin
            If DWORD(Addr) < $80000000 Then
               Inc(Result,Mem.RegionSize);
            end;
         end;
   CloseHandle(hProcess);
   end
Else Result:=-1;
end;

Function DejPocetGDIHandlu(PID:Cardinal):Int64;
Var hProcess : THandle;
begin
hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,PID);
If hProcess > 0 Then
   begin
   Result:=GetGUIResources(hProcess,GR_GDIOBJECTS);
   CloseHandle(hProcess);
   end
Else Result:=-1;
end;

Function DejPocetUserHandlu(PID:Cardinal):Int64;
Var hProcess : THandle;
begin
hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,PID);
If hProcess > 0 Then
   begin
   Result:=GetGUIResources(hProcess,GR_USEROBJECTS);
   CloseHandle(hProcess);
   end
Else Result:=-1;
end;

Function  DejPocetHandlu(PID:Cardinal):Int64;
Type TGetProcessHandleCount = Function (hProcess:THandle; Var hCount:DWORD):Boolean; StdCall;
Var  GetProcessHandleCount : TGetProcessHandleCount;
     hProcess : THandle;
     R : Cardinal;
begin
Result:=-1;
GetProcessHandleCount:=GetProcAddress(GetModuleHandle('KERNEL32.DLL'),'GetProcessHandleCount');
If Assigned(GetProcessHandleCount) Then
   begin
   hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,PID);
   If hProcess > 0 Then
      begin
      If GetProcessHandleCount(hProcess,R) Then
         Result:=R;
      CloseHandle(hProcess);
      end;
   end;
end;

Function  NactiPametProcesu(PID:Cardinal; Odkud,Kam:Pointer; Pocet:Cardinal; Var Readed:Cardinal):Cardinal;
Var hProcess : THandle;
    Read : Cardinal;
begin
Result:=0;
If (Cardinal(Odkud) < $80000000) Then
   begin
   hProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_READ,False,PID);
   If hProcess > 0 Then
      begin
      ReadProcessMemory(hProcess,Odkud,Kam,Pocet,Read);
      If Pocet <> Read Then
         Result:=GetLastError;
      CloseHandle(hProcess);
      Readed:=0;
      end
   Else Result:=GetLastError;
   end
Else If WinNT Then
        begin
        Readed:=Pocet;
        If GetKernelMemory(Cardinal(Odkud),Pocet,Kam) = STATUS_SUCCESS Then
           Result:=Pocet
        Else Readed:=0;
        end
Else SetLastError(ERROR_INVALID_PARAMETER);
end;

Function  LzeCistPamet(PID:Cardinal):Boolean;
Var hProcess : THandle;
begin
hProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_READ,False,PID);
Result:=hProcess > 0;
If Result Then
   CloseHandle(hProcess);
end;

Procedure  ZaregistrujJakoSluzbu(PID:Cardinal);
Var hKernel : hModule;
    PRegServiceProcess : Function (dwProcessId, dwType:DWORD):DWord; StdCall;
begin
If WinNT Then
   Exit;
hKernel:=GetModuleHandle('kernel32.dll');
If hKernel > 0 Then
   begin
   PRegServiceProcess:=GetProcAddress(hKernel,'RegisterServiceProcess');
   If @PRegServiceProcess <> Nil Then
      PRegServiceProcess(PID,RSP_SIMPLE_SERVICE)
   end;
end;

Procedure Odregistruj(PID:Cardinal);
Var hKernel : hModule;
    PRegServiceProcess : Function (dwProcessId, dwType:DWORD):DWord; StdCall;
begin
If WinNT Then
   Exit;
hKernel:=GetModuleHandle('kernel32.dll');
If hKernel > 0 Then
   begin
   PRegServiceProcess:=GetProcAddress(hKernel,'RegisterServiceProcess');
   If @PRegServiceProcess <> Nil Then
      PRegServiceProcess(PID,RSP_UNREGISTER_SERVICE)
   end;
end;


Function  ProcessTimes(PID:Cardinal; Var Created,Exited:TDateTime; Var Kernel,User:Int64):Boolean;
Var hProcess : THandle;
    C, K, U, E : FILETIME;
    Time, Date : Word;
begin
Result:=False;
hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,PID);
If hProcess > 0 Then
   begin
   Result:=GetProcessTimes(hProcess,C,E,K,U);
   If Result Then
      begin
      FileTimeToDosDateTime(C,Date,Time);
      Created:=FileDateToDateTime(Date Shl 16+Time);
      FileTimeToDosDateTime(E,Date,Time);
      Exited:=FileDateToDateTime(Date Shl 16+Time);
      Kernel:=Int64(K) Div 1000000;
      User:=Int64(U) Div 1000000;
      end;
   CloseHandle(hProcess);
   end;
end;

Function DejSouborZTID(TID:Cardinal):String;
begin
Result:=DejSouborZPID(DejRodiceVlakna(TID));
end;

Function DejRodiceVlakna(TID:Cardinal):Cardinal;
Var hSnap : THandle;
    TE    : ThreadEntry32;
begin
Result:=0;
If Not (Win9xMe Or WinXP) Then
   Exit;
hSnap:=CreateToolHelp32Snapshot(TH32CS_SNAPTHREAD,0);
If hSnap > 0 Then
   begin
   TE.dwSize:=SizeOf(TE);
   If Thread32First(hSnap,TE) Then
      begin
      Repeat
      If TE.th32ThreadID = TID Then
         begin
         Result:=TE.th32OwnerProcessID;
         Break;
         end;
      Until Not Thread32Next(hSnap,TE);
      end;
   CloseHandle(hSnap);
   end;
end;

Function  DejSouborZPID(PID:Cardinal):String;
Var hSnap : THandle;
    PE    : ProcessEntry32;
begin
Result:='';
If Not (Win9xMe Or WinXP) Then
   Exit;
hSnap:=CreateToolHelp32Snapshot(TH32CS_SNAPPROCESS,0);
If hSnap > 0 Then
   begin
   PE.dwSize:=SizeOf(PE);
   If Process32First(hSnap,PE) Then
      begin
      Repeat
      If PE.th32ProcessID = PID Then
         begin
         Result:=PE.szExeFile;
         Break;
         end;
      Until Not Process32Next(hSnap,PE);
      end;
   CloseHandle(hSnap);
   end;
end;

Procedure Uspi(PID:Cardinal; Uspat:Boolean);
Var hThread : THandle;
    TE      : ThreadEntry32;
    hSnap   : Cardinal;
begin
hSnap:=CreateToolHelp32Snapshot(TH32CS_SNAPTHREAD,0);
If hSnap > 0 Then
   begin
   TE.dwSize:=SizeOf(TE);
   If Thread32First(hSnap,TE) Then
      begin
      Repeat
      If TE.th32OwnerProcessID = PID Then
         begin
         hThread:=UniversalOpenThread(THREAD_SUSPEND_RESUME,False,TE.th32ThreadID);
         If hThread <> 0 Then
            begin
            If Uspat Then
               SuspendThread(hThread)
            Else ResumeThread(hThread);
            CloseHandle(hThread);
            end
         Else ErrorMessage(SysErrorMessage(GetLastError));
         end;
      Until Not Thread32Next(hSnap,TE);
      end;
   CloseHandle(hSnap);
   end;
end;

Procedure SuspendProcess(PID:Cardinal);
begin
If PID <> GetCurrentProcessID Then
   Uspi(PID,True);
end;

Procedure ResumeProcess(PID:Cardinal);
begin
If PID <> GetCurrentProcessID Then
   Uspi(PID,False);
end;

Procedure KillProcess(PID:Cardinal);
Var hProcess : THandle;
begin
hProcess:=OpenProcess(PROCESS_TERMINATE,False,PID);
If hProcess > 0 Then
   begin
   TerminateProcess(hProcess,0);
   CloseHandle(hProcess);
   end;
end;

Procedure RunProcess(ProcessFileName:String);
begin
WinExec(PAnsiChar(ProcessFileName),SW_NORMAL);
end;

Function  DejSouborProcesu(APID:Cardinal):String;
Var hSnap : Cardinal;
    ME    : ModuleEntry32;
begin
Result:='';
If Not (Win9xMe Or WinXP) Then
   Exit;
HSnap:=CreateToolHelp32Snapshot(TH32CS_SNAPMODULE,APID);
If HSnap > 0 Then
   begin
   ME.dwSize:=SizeOf(ME);
   If Module32First(HSnap,ME) Then
      begin
      Repeat
      If AnsiUpperCase(ExtractFileExt(ME.szExePath)) = '.EXE' Then
         begin
         Result:=ME.szExePath;
         Break;
         end;
      Until Not Module32Next(HSnap,ME);
      end;
   CloseHandle(HSnap);
   end;
end;

Function ProcessSearchInit:THandle;
begin
If Win9xMe Then
   Result:=Win95ProcessSearchInit
Else Result:=WinNTProcessSearchInit;
end;

Function ProcessSearchFirst(hSearch:THandle; Var PE:ProcessEntry32):Boolean;
begin
If Win9xMe Then
   Result:=Win95ProcessSearchFirst(hSearch,PE)
Else Result:=WinNTProcessSearchFirst(hSearch,PE);
end;

Function ProcessSearchNext(hSearch:THandle; Var PE:ProcessEntry32):Boolean;                                         StdCall;
begin
If Win9xMe Then
   Result:=Win95ProcessSearchNext(hSearch,PE)
Else Result:=WinNTProcessSearchNext(hSearch,PE);
end;

Procedure ProcessSearchDestroy(hSearch:THandle); StdCall;
begin
If Win9xMe Then
   Win95ProcessSearchDestroy(hSearch)
Else WinNTProcessSearchDestroy(hSearch);
end;

Procedure DejOblastiPametiProcesu(PID:Cardinal; CallBack:TMemoryCallBack);   StdCall;
Var hProcess : THandle;
    Mem      : _MEMORY_BASIC_INFORMATION;
    Addr     : Pointer;
begin
If Not Assigned(CallBack) Then
   Exit;
hProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_QUERY_INFORMATION,False,PID);
If hProcess > 0 Then
   begin
   Addr:=Nil;
   While VirtualQueryEx(hProcess,Addr,Mem,SizeOf(Mem)) <> 0 Do
         begin
         Addr:=Pointer(Cardinal(Mem.BaseAddress)+Mem.RegionSize);
         If Not CallBack(Mem) Then
            Break;
         end;
   If GetLastError <> NO_ERROR Then
      ErrorMessage('VyrtualQueryEx: '+SysErrorMessage(GetLastError));
   CloseHandle(hProcess);
   end
Else ErrorMessage('OpenProcess: '+SysErrorMessage(GetLastError));
end;

Function QueryProcessTimes(PID:Cardinal; Var Create,Exit:TDateTime; Var User,Kernel:Int64):Boolean; StdCall;
Var hProcess : THandle;
    E,C,K,U : FILETIME;
    SysTime : _SYSTEMTIME;
begin
Result:=False;
hProcess:=OpenProcess(PROCESS_QUERY_INFORMATION,False,PID);
If hProcess > 0 Then
   begin
   If GetProcessTimes(hProcess,C,E,K,U) Then
      begin
      Result:=True;
      User:=Int64(U);
      Kernel:=Int64(K);
      User:=User Div 10;
      Kernel:=Kernel Div 10;
      FileTimeToSystemTime(C,SysTime);
      Create:=SystemTimeToDateTime(SysTime);
      FileTimeToSystemTime(E,SysTime);
      Exit:=SystemTimeToDateTime(SysTime);
      end;
   CloseHandle(hProcess);
   end;
end;

end.
