Unit ProcessInfoForm;

Interface

Uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ClassProcesy,
  ClassModule, ClassVlakna, Menus;

Type
  TProcessInfo = Class (TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    TabSheet9: TTabSheet;
    ModulyListView: TListView;
    VlaknaListView: TListView;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Refresh1: TMenuItem;
    Konec1: TMenuItem;
    Moduly1: TMenuItem;
    Pidat1: TMenuItem;
    Odebrat1: TMenuItem;
    Importyaexporty1: TMenuItem;
    Vlkna1: TMenuItem;
    Uspat1: TMenuItem;
    Probudit1: TMenuItem;
    Ukonit1: TMenuItem;
    Vceinformac1: TMenuItem;
    Procedure ModulyListViewColumnClick(Sender: TObject;
      Column: TListColumn);
    Procedure ModulyListViewData(Sender: TObject; Item: TListItem);
    Procedure PageControl1Change(Sender: TObject);
    Procedure FormDestroy(Sender: TObject);
    Procedure VlaknaListViewColumnClick(Sender: TObject;
      Column: TListColumn);
    Procedure VlaknaListViewData(Sender: TObject; Item: TListItem);
    Procedure Importyaexporty1Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
  Private
    FPID    : Cardinal;
    FInfo   : PProcess;
    FModuly : TModuly;
    FVlakna : TVlakna;
  Public
    Constructor Create(AOwner:TComponent; AInfo:PProcess); Reintroduce; Virtual;
  end;

Procedure CreateInfoOProcesuForm(AHandle:THandle; AInfo:Pointer); StdCall;

Implementation

Uses ShellAPI;

Procedure CreateInfoOProcesuForm(AHandle:THandle; AInfo:Pointer); StdCall;
begin
Application.Handle:=AHandle;
With TProcessInfo.Create(Application,AInfo) Do
     begin
     ShowModal;
     Free;
     end;
end;

{$R *.DFM}

Constructor TProcessInfo.Create(AOwner:TComponent; AInfo:PProcess);
Var Zaznam : _SHFILEINFOA;
begin
Inherited Create(AOwner);
FInfo:=AInfo;
FPID:=AInfo.th32ProcessID;
FModuly:=TModuly.Create(FPID);
With FModuly Do
     begin
     ListView:=ModulyListView;
     SloupecZmenStav(MODULY_SLOUPEC_NAME,True);
     SloupecZmenStav(MODULY_SLOUPEC_PATH,True);
     SloupecZmenStav(MODULY_SLOUPEC_BASE,True);
     SloupecZmenStav(MODULY_SLOUPEC_SIZE,True);
     SloupecZmenStav(MODULY_SLOUPEC_REFS,True);
     UpravSloupceNaListViewu;
     end;
With ModulyListView Do
     begin
     SmallImages:=TImageList.Create(ModulyListView);
     SmallImages.ShareImages:=True;
     SmallImages.Handle:=SHGetFileInfo(PAnsiChar(Application.ExeName),0,Zaznam,SizeOf(Zaznam),SHGFI_ICON Or SHGFI_SYSICONINDEX Or SHGFI_SMALLICON);
     DestroyIcon(Zaznam.hIcon);
     end;
FVlakna:=TVlakna.Create(FPID);
With FVlakna Do
     begin
     ListView:=VlaknaListView;
     SloupecZmenStav(VLAKNA_SLOUPEC_TID,True);
     SloupecZmenStav(VLAKNA_SLOUPEC_PRIORITY,True);
     SloupecZmenStav(VLAKNA_SLOUPEC_SUSPENDED,True);
     UpravSloupceNaListViewu;
     end;
end;

Procedure TProcessInfo.ModulyListViewColumnClick(Sender: TObject;
  Column: TListColumn);
begin
FModuly.ListViewColumnClick(Sender,Column);
end;

Procedure TProcessInfo.ModulyListViewData(Sender: TObject;
  Item: TListItem);
begin
FModuly.ListViewVykresliJednoho(Sender,Item);
end;

Procedure TProcessInfo.PageControl1Change(Sender: TObject);
begin
Case PageControl1.ActivePageIndex Of
     1 : FModuly.Enumerate;
     2 : FVlakna.Enumerate;
     end;
end;

Procedure TProcessInfo.FormDestroy(Sender: TObject);
begin
FModuly.Free;
end;

Procedure TProcessInfo.VlaknaListViewColumnClick(Sender: TObject;
  Column: TListColumn);
begin
FVlakna.ListViewColumnClick(Sender,Column);
end;

Procedure TProcessInfo.VlaknaListViewData(Sender: TObject;
  Item: TListItem);
begin
FVlakna.ListViewVykresliJednoho(Sender,Item);
end;

Procedure TProcessInfo.Importyaexporty1Click(Sender: TObject);
begin
If Assigned(ModulyListView.Selected) Then
   FModuly.ShowInfo(ModulyListView.Selected.Index);
end;

Procedure TProcessInfo.Refresh1Click(Sender: TObject);
begin
PageControl1Change(Nil);
end;

Procedure TProcessInfo.Konec1Click(Sender: TObject);
begin
Close;
end;

End.
