Unit TProcMain;

Interface

Uses Windows, TlHelp32;

Function UniversalOpenThread(dwDesiredAccess:Cardinal; fInherit:Boolean; TID:Cardinal):Cardinal; StdCall;
Function UniversalThreadSetContext(TID:Cardinal; Context: _CONTEXT):Boolean; StdCall;
Function UniversalThreadGetContext(TID:Cardinal; Var Context: _CONTEXT):Boolean; StdCall;
Function ThreadGetID(hThread:Thandle):Cardinal; StdCall;
Function ThreadSearchInit:THandle;  StdCall;
Function ThreadSearchFirst(hSearch:Thandle; Var TE:ThreadEntry32):Boolean; StdCall;
Function ThreadSearchNext(hSearch:THandle; Var TE:ThreadEntry32):Boolean;  StdCall;
Procedure ThreadSearchDestroy(hSearch:THandle); StdCall;

Implementation

Uses OSVersion, Win95Functions,
     WinNTFunctions;

Function UniversalThreadGetContext(TID:Cardinal; Var Context: _CONTEXT):Boolean;
Var hThread : THandle;
begin
Result:=False;
hThread:=UniversalOpenThread(THREAD_GET_CONTEXT Or THREAD_SUSPEND_RESUME,False,TID);
If hThread > 0 Then
   begin
   If SuspendThread(hThread) <> INVALID_HANDLE_VALUE Then
      begin
      Context.ContextFlags:=CONTEXT_FULL;
      Result:=GetThreadContext(hThread,Context);
      ResumeThread(hThread);
      end
   Else SetLastError(GetLastError);
   CloseHandle(hThread);
   end
Else SetLastError(GetLastError);
end;

Function UniversalThreadSetContext(TID:Cardinal; Context: _CONTEXT):Boolean;
Var hThread : THandle;
begin
Result:=False;
hThread:=UniversalOpenThread(THREAD_SET_CONTEXT Or THREAD_SUSPEND_RESUME,False,TID);
If hThread > 0 Then
   begin
   If SuspendThread(hThread) <> INVALID_HANDLE_VALUE Then
      begin
      Result:=SetThreadContext(hThread,Context);
      ResumeThread(hThread);
      end
   Else SetLastError(GetLastError);
   CloseHandle(hThread);
   end
Else SetLastError(GetLastError);
end;

Function  UniversalOpenThread(dwDesiredAccess:Cardinal; fInherit:Boolean; TID:Cardinal):Cardinal;
Var OpenThread : Function (dwDesiredAccess:Cardinal; fInherit:Boolean; dwThreadID:Cardinal):THandle; StdCall;
    hKernel : THandle;
begin
Result:=0;
If Win9xMe Then
   Result:=Win95OpenThread(dwDesiredAccess,fInherit,TID)
Else If WinXP Or Win2000 Or WinNT4 Then
        begin
        hKernel:=LoadLibrary('KERNEL32.DLL');
        If hKernel > 0 Then
           begin
           OpenThread:=GetProcAddress(hKernel,'OpenThread');
           Result:=OpenThread(dwDesiredAccess,fInherit,TID);
           FreeLibrary(hKernel);
           end
        Else Result:=0;
        end
Else SetLastError(ERROR_ACCESS_DENIED);
SetLastError(GetLastError);
end;

Function ThreadSearchInit:THandle;  StdCall;
begin
Result:=0;
If (Win9xMe) Or (WinXP) Then
   Result:=Win95ThreadSearchInit;
end;

Function ThreadSearchFirst(hSearch:Thandle; Var TE:ThreadEntry32):Boolean; StdCall;
begin
Result:=False;
If (Win9xMe) Or (WinXP) Then
   Result:=Win95ThreadSearchFirst(hSearch,TE);
end;

Function ThreadSearchNext(hSearch:THandle; Var TE:ThreadEntry32):Boolean;  StdCall;
begin
Result:=False;
If (Win9xMe) Or (WinXP) Then
   Result:=Win95ThreadSearchNext(hSearch,TE);
end;

Procedure ThreadSearchDestroy(hSearch:THandle); StdCall;
begin
If (Win9xMe) Or (WinXP) Then
   Win95ThreadSearchDestroy(hSearch);
end;

Function ThreadContextEqual(A,B:_CONTEXT):Boolean; StdCall;
begin
Result:=False;
If (A.SegGs = B.SegGs)   And
   (A.SegFs = B.SegFs)   And
   (A.SegEs = B.SegES)   And
   (A.SegDs = B.SegDs)   And
   (A.SegCs = B.SegCs)   And
   (A.Edi = B.Edi)       And
   (A.Esi = B.Esi)       And
   (A.Eax = B.Eax)       And
   (A.Ebx = B.Ebx)       And
   (A.Ecx = B.Ecx)       And
   (A.Edx = B.Edx)       And
   (A.Esp = B.Esp)       And
   (A.Eip = B.Eip)       And
   (A.SegSS = B.SegSS)   And
   (A.EFlags = B.EFlags) And
   (A.Ebp = B.Ebp) Then
   Result:=True;
end;

Function ThreadGetID(hThread:Thandle):Cardinal; StdCall;
Var TBI : THREAD_BASIC_INFORMATION;
begin
Result:=0;
If NtQueryInformationThread(hThread,ThreadBasicInformation,@TBI,SizeOf(TBI),Nil) = STATUS_SUCCESS Then
   Result:=TBI.ClientId.UniqueThread;
end;

end.
