Unit DLLInterface;

Interface

Const
      ERROR_DLL_NOT_FOUND    = 1;
      ERROR_EXPORT_NOT_FOUND = 2;

      ACTION_NONE            = 0;
      ACTION_EXITPROCESS     = 1;

Type
    TErrorCallback = Function (dwErrorType:Cardinal; S1:String; S2:String):Cardinal; StdCall;

Procedure  DLLLoad(DllName:String);
Procedure  GetExportAddress(Var E:Pointer; ExportName:String);
Procedure  SetErrorProc(P:TErrorCallback);

Implementation

Uses Windows;

Var DLLLoaded     : THandle;
    DLLLoadedName : String;
    ErrorProc     : TErrorCallback;

Function DefaultErrorProc(dwErrorType:Cardinal; S1, S2:String):Cardinal; StdCall;
begin
Result:=ACTION_EXITPROCESS;
Case dwErrorType Of
     ERROR_DLL_NOT_FOUND    : MessageBox(0,PAnsiChar('Knihovna '+S1+' nenalezena!'),'Chyba!',MB_OK Or MB_ICONERROR);
     ERROR_EXPORT_NOT_FOUND : MessageBox(0,PAnsiChar('Export knihovny '+S1+' '+S2+' nenalezen!'),'Chyba!',MB_OK Or MB_ICONERROR);
     end;
end;

Procedure DLLLoad(DllName:String);
begin
DLLLoadedName:='';
DLLLoaded:=LoadLibrary(PAnsiChar(DllName));
If DLLLoaded <> 0 Then
   DLLLoadedName:=DllName
Else Case ErrorProc(ERROR_DLL_NOT_FOUND,DllName,'') Of
     ACTION_NONE        : begin end;
     ACTION_EXITPROCESS : ExitProcess(1);
     end;
end;

Procedure GetExportAddress(Var E:Pointer; ExportName:String);
begin
E:=GetProcAddress(DLLLoaded,PAnsiChar(ExportName));
If (E = Nil) Then
   Case ErrorProc(ERROR_EXPORT_NOT_FOUND,DLLLoadedName,ExportName) Of
        ACTION_NONE        : begin end;
        ACTION_EXITPROCESS : ExitProcess(1);
        end;
end;

Procedure  SetErrorProc(P:TErrorCallback);
begin
ErrorProc:=P;
end;

Initialization
SetErrorProc(DefaultErrorProc);
End.
