Unit Win95Functions;

//////////////////////////////////////////
// Soubor: WIN95FUNCTIONS.PAS           //
// Verze:  1.0                          //
// Autor:  Vrtule (vrtulex@seznam.cz)   //
// Popis:  Importn unita pro           //
//         Win9xFunctions.dll           //
//////////////////////////////////////////

Interface

Uses Windows, TlHelp32;

// Konstany pro Pstup k vlknm pomoc
// Win95OpenThread
Const THREAD_QUERY_INFORMATION    = $40;
      THREAD_SET_INFORMATION      = $20;
      THREAD_SET_THREAD_CONTEXT   = $80;
      THREAD_SUSPEND_RESUME       = $2;
      THREAD_TERMINATE            = $1;
      THREAD_ALL_ACCESS           = $1F03FF;
      THREAD_GET_CONTEXT          = $8;
      THREAD_DIRECT_IMPRESONATION = $200;
      THREAD_IMPERSONATE          = $100;
      THREAD_SET_CONTEXT          = $10;
      THREAD_SYNCHRONIZE          = $100000;

      Win9xFunctionsLib           = 'WIN9XFUNCTIONS.DLL';

      KOBJECT_SEMAPHORE           = 1;
      KOBJECT_EVENT               = 2;
      KOBJECT_MUTEX               = 3;
      KOBJECT_CRITICAL_SECTION    = 4;
      KOBJECT_PROCESS             = 6;
      KOBJECT_THREAD              = 7;
      KOBJECT_FILE                = 8;
      KOBJECT_CHANGE              = 9;
      KOBJECT_CONSOLE             = -1;
      KOBJECT_SCREEN_BUFFER       = -4;
      KOBJECT_MEM_MAPPED_FILE     = 13;
      KOBJECT_SERIAL              = -3;
      KOBJECT_DEVICE_IOCTL        = 15;
      KOBJECT_PIPE                = 16;
      KOBJECT_MAILSLOT            = -2;
      KOBJECT_TOOLHELP_SNAPSHOT   = 18;
      KOBJECT_SOCKET              = 19;

Type
      THandleObject  = Packed Record
                       ObjectType     : DWord;
                       end;
      PHandleObject = ^THandleObject;
      TProcessHandle = Packed Record
                       GuarantedAccess : DWORD;
                       HObject          : PHandleObject;
                       end;
      PProcessHandle = ^TProcessHandle;
      TProcessHandleTable = Packed Record
                            dwMaxHandles : Cardinal;
                            Handles : Packed Array [0..0] Of TProcessHandle;
                            end;
      PProcessHandleTable = ^TProcessHandleTable;

// Uvoln pam alokovanou funkc
// Win95VirtualAllocEx
// Parametry jsou stejn jako ve VirtualFree
Function   Win95VirtualFreeEx(lpAddress:Pointer; dwSize:DWORD; dwFreeType:DWORD):Boolean; StdCall;
// Alokuje pam sdlenou mezi vemi
// procesy (trochu obdoba VirtualAllocEx)
// Parametry jsou stejn jako u
// VirtualAlloc
Function   Win95VirtualAllocEx(lpAddress:Pointer; dwSize:DWORD; fAllocationType:DWORD; flProtect:DWORD):Pointer; StdCall;
// Vlo modul do procesu
// PID        - id procesu
// ModuleName - cel nzev souboru modulu
Function   Win98InjectModule(PID:Cardinal; ModuleName:PChar):DWORD;  StdCall;
// Provd to sam jako CreateRemoteThread
// ve Windows NT
// PID - id procesu
// Start - adresa startu vlkna
// Parameter - parametr pedan hlavn
// rutin vlkna
// Vrt Handle vlkna
Function   Win98CreateRemoteThread(PID:Cardinal; Start:Pointer; Parameter:Pointer):THandle; StdCall;
// Ukon proces pomoc ExitProcess
// PID - id procesu
Procedure  Win98TerminateProcess(PID:Cardinal);
// Odstran modul z procesu
// PID - id procesu
// BaseAddr - adresa v pamti, kde je modul nahrn
Procedure  Win98RemoveModule(PID:Cardinal; BaseAddr:Pointer);
// Dl to sam jako OpenThread ve
// Windows NT. Parametry jsou tak stejn
Function   Win95OpenThread(Access:DWORD; Inherit:Boolean; TID:DWORD):THandle; StdCall;


// Vrt handle (umstn v adresovm
// prostoru) modulu MODULENAME v procesu
// APID
Function   Win95GetRemoteModuleHandle(APID:Cardinal; ModuleName:String):Cardinal; StdCall;

Function GetObsFucator:DWORD; StdCall;
Function GetPDB(PID:DWORD):Pointer;                                   StdCall;
Function Win95GetProcessHandleTable(PID:Cardinal):PProcessHandleTable; StdCall;

Function  Win95ModuleSearchInit(PID:Cardinal):Cardinal;                         StdCall;
Function  Win95ModuleSearchFirst(hSearch:THandle; Var ME:ModuleEntry32):Boolean; StdCall;
Function  Win95ModuleSearchNext(hSearch:THandle; Var ME:ModuleEntry32):Boolean; StdCall;
Procedure Win95ModuleSearchDestroy(hSearch:THandle); StdCall;

Function  Win95ProcessSearchInit:THandle;   StdCall;
Function  Win95ProcessSearchFirst(hSearch:THandle; Var PE:ProcessEntry32):Boolean;  StdCall;
Function  Win95ProcessSearchNext(hSearch:THandle; Var PE:ProcessEntry32):Boolean;                                         StdCall;
Procedure Win95ProcessSearchDestroy(hSearch:THandle);  StdCall;

Function Win95ThreadSearchInit:THandle;                                         StdCall;
Function Win95ThreadSearchFirst(hSearch:THandle; Var TE:ThreadEntry32):Boolean; StdCall;
Function Win95ThreadSearchNext(hSearch:THandle; Var TE:ThreadEntry32):Boolean;  StdCall;
Procedure Win95ThreadSearchDestroy(hSearch:THandle); StdCall;

Implementation

Uses SysUtils;

Function Win95GetProcessHandleTable(PID:Cardinal):PProcessHandleTable;
begin
Result:=PProcessHandleTable(PDWORD(Cardinal(GetPDB(PID))+$44)^);
end;

Function GetObsFucator:DWORD;
Var PID, PDB : DWORD;
begin
PID:=GetCurrentProcessID;
Asm
MOV EAX, FS:[30h]
MOV PDB, EAX
end;
Result:= PDB Xor PID;
end;

Function GetPDB(PID:DWORD):Pointer;
begin
Result:=Pointer(PID Xor GetObsFucator);
end;


Function Win95VirtualAllocEx(lpAddress:Pointer; dwSize:DWORD; fAllocationType:DWORD; flProtect:DWORD):Pointer;
Const VA_SHARED = $8000000;
begin
Result:=VirtualAlloc(lpAddress,dwSize,fAllocationType Or VA_SHARED,flProtect);
end;

Function Win95VirtualFreeEx(lpAddress:Pointer; dwSize:DWORD; dwFreeType:DWORD):Boolean;
begin
Result:=VirtualFree(lpAddress,dwSize,dwFreeType);
end;

Function  Win98CreateRemoteThread(PID:Cardinal; Start:Pointer; Parameter:Pointer):THandle;
Var Pom : DWORD;
begin
 Asm
 PUSH PID
 CALL GetPDB
 PUSH 00000048h
 MOV EDI, Parameter
 PUSH EDI
 PUSH Start
 PUSH -00003000h
 MOV EDI, EAX
 PUSH EDI
 MOV EAX, 0BFF929F1h
 CALL EAX
 PUSH EAX
 PUSH 500
 CALL Sleep
 POP EAX
 PUSH EAX
 CALL GetObsfucator
 POP EBX
 XOR EBX, EAX
 MOV EAX, EBX
 MOV Pom, EAX
 PUSH EAX
 PUSH False
 PUSH THREAD_ALL_ACCESS
 CALL Win95OpenThread
 PUSH EAX
 PUSH EAX
 CALL ResumeThread
 POP EAX
 MOV Result, EAX
 POP EAX
 MOV Result, EAX
 end;
end;

Function  Win98InjectModule(PID:Cardinal; ModuleName:PChar):DWORD;
Var Addr     : Pointer;
    hProcess : THandle;
    Written  : Cardinal;
    LoadLibA : Pointer;
    hKernel  : THandle;
    hThread  : THandle;
begin
Result:=0;
hProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_WRITE Or PROCESS_CREATE_THREAD,False,PID);
If hProcess > 0 Then
   begin
   Addr:=Win95VirtualAllocEx(Nil,Length(ModuleName)+1,MEM_COMMIT,PAGE_EXECUTE_READWRITE);
   If Assigned(Addr) Then
      begin
      WriteProcessMemory(hProcess,Addr,ModuleName,Length(ModuleName),Written);
      If Written = Cardinal(Length(ModuleName)) Then
         begin
         hKernel:=GetModuleHandle('KERNEL32.DLL');
         If hKernel > 0 Then
            begin
            LoadLibA:=GetProcAddress(hKernel,'LoadLibraryA');
            If Assigned(LoadLibA) Then
               begin
               hThread:=Win98CreateRemoteThread(PID,LoadLibA,Addr);
               GetExitCodeThread(hThread,Result);
               end;
            end;
         end;
      Sleep(1000);
      Win95VirtualFreeEx(Addr,Length(ModuleName),MEM_DECOMMIT);
      end;
   CloseHandle(hProcess);
   end;
end;

Procedure Win98TerminateProcess(PID:Cardinal);
Var EP : Pointer;
begin
EP:=GetProcAddress(GetModuleHandle('KERNEL32.DLL'),'ExitProcess');
If Assigned(EP) Then
   begin
   Win98CreateRemoteThread(PID,EP,Pointer(25));
   Sleep(500);
   end;
end;

Procedure Win98RemoveModule(PID:Cardinal; BaseAddr:Pointer);
Var FreeLib : Pointer;
    hKernel : THandle;
    hThread : THandle;
begin
Asm
PUSHAD
end;
hKernel:=GetModuleHandle('KERNEL32.DLL');
If hKernel > 0 Then
   begin
   FreeLib:=GetProcAddress(hKernel,'FreeLibrary');
   If Assigned(FreeLib) Then
      hThread:=Win98CreateRemoteThread(PID,FreeLib,BaseAddr);
   WaitForSingleObject(hThread,1000);
   CloseHandle(hThread);
   end;
Asm
POPAD
end;
end;

Function   Win95OpenThread(Access:DWORD; Inherit:Boolean; TID:DWORD):THandle; StdCall;
Var pTDB : Pointer;
begin
pTDB:=Pointer(TID Xor GetObsfucator);
Asm
(*
BFF730B8*
BFF84F1E*
BFF95D90****
BFF9D696*
BFF9D7A1*
BFFB99E1*
BFFB99FF*
BFFB9BD7*
BFFB9BF5*
BFFBC80B*
BFFBD522*
BFFBD74A*
BFFBCF6B*
BFFBCF9B*
BFFBCFF4*
BFFBFCE4*
BFFBD95C*
BFFBDB52*
*)
MOV EAX , pTDB
PUSH TID
PUSH 00000000h
PUSH Access
MOV EDI, 0BFF95D90h
CALL EDI
MOV Result, EAX
end;
end;

Function   Win95GetRemoteModuleHandle(APID:Cardinal; ModuleName:String):Cardinal; StdCall;
Var hSnap : THandle;
    ME    : ModuleEntry32;
begin
Result:=0;
hSnap:=CreateToolHelp32SnapShot(TH32CS_SNAPMODULE,APID);
If hSnap > 0 Then
   begin
   ME.dwSize:=SizeOf(ME);
   If Module32First(hSnap,ME) Then
      begin
      Repeat
      If AnsiUpperCase(ME.szExePath) = AnsiUpperCase(ModuleName) Then
         begin
         Result:=Cardinal(ME.modBaseAddr);
         Break;
         end;
      Until Not Module32Next(hSnap,ME);
      end;
   CloseHandle(hSnap);
   end;
end;

Function  Win95ModuleSearchInit(PID:Cardinal):Cardinal;
begin
Result:=CreateToolHelp32SnapShot(TH32CS_SNAPMODULE,PID);
end;

Function  Win95ModuleSearchFirst(hSearch:THandle; Var ME:ModuleEntry32):Boolean;
begin
ME.dwSize:=SizeOf(ME);
Result:=Module32First(hSearch,ME);
end;

Function  Win95ModuleSearchNext(hSearch:THandle; Var ME:ModuleEntry32):Boolean;
begin
Result:=Module32Next(hSearch,ME);
end;

Procedure Win95ModuleSearchDestroy(hSearch:THandle); StdCall;
begin
CloseHandle(hSearch);
end;

Function Win95ProcessSearchInit:THandle;
begin
Result:=CreateToolHelp32Snapshot(TH32CS_SNAPPROCESS,0);
end;

Function Win95ProcessSearchFirst(hSearch:THandle; Var PE:ProcessEntry32):Boolean;
begin
PE.dwSize:=SizeOf(PE);
Result:=Process32First(hSearch,PE);
end;

Function Win95ProcessSearchNext(hSearch:THandle; Var PE:ProcessEntry32):Boolean;                                         StdCall;
begin
Result:=Process32Next(hSearch,PE);
end;

Procedure Win95ProcessSearchDestroy(hSearch:THandle);
begin
CloseHandle(hSearch);
end;

Function Win95ThreadSearchInit:THandle;                                         StdCall;
begin
Result:=CreateToolHelp32Snapshot(TH32CS_SNAPTHREAD,0);
end;

Function Win95ThreadSearchFirst(hSearch:THandle; Var TE:ThreadEntry32):Boolean; StdCall;
begin
TE.dwSize:=SizeOf(TE);
Result:=Thread32First(hSearch,TE);
end;

Function Win95ThreadSearchNext(hSearch:THandle; Var TE:ThreadEntry32):Boolean;  StdCall;
begin
Result:=Thread32Next(hSearch,TE);
end;

Procedure Win95ThreadSearchDestroy(hSearch:THandle); StdCall;
begin
CloseHandle(hSearch);
end;

End.
