Unit ModuleInformationForm;

Interface

Uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ClassExports,
  ClassImports;

Type
  TModuleInformation = Class (TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ExportyListView: TListView;
    ImportyListView: TListView;
    Procedure FormCreate(Sender: TObject);
    Procedure PageControl1Change(Sender: TObject);
    Procedure FormDestroy(Sender: TObject);
    Procedure ImportyListViewColumnClick(Sender: TObject;
      Column: TListColumn);
    Procedure ImportyListViewData(Sender: TObject; Item: TListItem);
  Private
   FPID : Cardinal;
   FMN  : String;
   FExporty : TExporty;
   FImports : TModuleImports;
   FBase    : Cardinal;
   Constructor Create(AOwner:TComponent; APID:Cardinal; AModuleName:String; ABase:Cardinal); Reintroduce; Virtual;
  end;

Procedure CreateModuleInformationForm(AHandle:THandle; APID:Cardinal; AModuleName:String; Base:Cardinal); StdCall;

Implementation

Procedure CreateModuleInformationForm(AHandle:THandle; APID:Cardinal; AModuleName:String; Base:Cardinal); StdCall;
begin
Application.Handle:=AHandle;
With TModuleInformation.Create(Application,APID,AModuleName,Base) Do
     begin
     ShowModal;
     Free;
     end;
end;

{$R *.DFM}

Constructor TModuleInformation.Create(AOwner:TComponent; APID:Cardinal; AModuleName:String; ABase:Cardinal);
begin
Inherited Create(AOwner);
FBase:=ABase;
FPID:=APID;
FMN:=AModuleName;
If FPID <> 0 Then
   Caption:=Caption+' - '+AModuleName
Else Caption:='Informace o driveru - '+AModuleName;
end;

Procedure TModuleInformation.FormCreate(Sender: TObject);
begin
FExporty:=TExporty.Create(ExportyListView,FPID,FBase);
FExporty.ModuleName:=FMN;
With FExporty Do
     begin
     SloupecZmenStav(EXPORTY_SLOUPEC_FNNAME,True);
     SloupecZmenStav(EXPORTY_SLOUPEC_ORDINAL,True);
     SloupecZmenStav(EXPORTY_SLOUPEC_BASE,True);
     UpravSloupceNaListViewu;
     end;
FImports:=TModuleImports.Create(ImportyListView,FPID);
FImports.ModuleName:=FMN;
FImports.Base:=FBase;
With FImports Do
     begin
     SloupecZmenStav(IMPORTS_SLOUPEC_IMPORTNAME,True);
     SloupecZmenStav(IMPORTS_SLOUPEC_IMPORTORDINAL,True);
     SloupecZmenStav(IMPORTS_SLOUPEC_IMPORTADDRESS,True);
     SloupecZmenStav(IMPORTS_SLOUPEC_DLLNAME,True);
     SloupecZmenStav(IMPORTS_SLOUPEC_STATUS,True);
     UpravSloupceNaListViewu;
     end;
end;

Procedure TModuleInformation.PageControl1Change(Sender: TObject);
begin
Case PageControl1.ActivePageIndex Of
     0 : begin end;
     1 : FExporty.Enumerate;
     2 : FImports.Enumerate;
     end;
end;

Procedure TModuleInformation.FormDestroy(Sender: TObject);
begin
FExporty.Free;
FImports.Free;
end;

Procedure TModuleInformation.ImportyListViewColumnClick(Sender: TObject;
  Column: TListColumn);
begin
FImports.ListViewColumnClick(Sender,Column);
end;

Procedure TModuleInformation.ImportyListViewData(Sender: TObject;
  Item: TListItem);
begin
FImports.ListViewVykresliJednoho(Sender,Item);
end;

End.
